// DATABASE.H - Definitions for DATABASE.C
// Written by Stefan Pfeiffer, DL1ELY@DB0PKE, 940407
// Last Modification: 960717
// (C) 1994 by Stefan Pfeiffer, DL1ELY@DB0PKE


#ifndef DATABASE_H


#define DATABASE_H
  

#include <stdio.h>
#include <string.h>
#include <alloc.h>
#include <ctype.h>
#include <stdlib.h>
#include <conio.h>
#include "input.h"
#include "tools.h"
#include "global.h"
#include "structs.h"
#include "dvideo.h"
#include "wildmat.h"
#include "secmem.h"


#define OK             0
#define OPEN_FILE_ERR  1
#define DISK_FULL_ERR  2
#define RENAME_ERR     3

#define INVALID_ID     1
#define FILE_NOT_FOUND 2

#define CHK_OK             0
#define CHK_UNKNOWN_PREFIX 1
#define CHK_WRONG_SQUARE   2


#define TMP_NAME       "$$$$$$$$.59"

#define INDEX_HEADER   "INDEX0\r\nIndices for FiveNine\r\n(C) 1994-95 by Stefan Pfeiffer, DL1ELY\r\n\x1A"
#define STATION_HEADER "STATIONS0\r\nStation-Database for FiveNine\r\n(C) 1994-95 by Stefan Pfeiffer, DL1ELY\r\n\x1A"


// QSO-Maske...
struct qso_mask
{
  unsigned min_nr, max_nr;
  unsigned char min_hour, max_hour;
  unsigned char min_minute, max_minute;
  char call[20];
  char loc[20];
  char mode;
  unsigned min_qrb, max_qrb;
  unsigned min_deg, max_deg;
};

  
// Externe Variablen fr EMS/XMS
//extern unsigned char use_ems;
//extern unsigned char use_xms;

// Root and last prefix of prefix-list
extern struct countryinfo *firstcountry;
extern struct countryinfo *lastcountry;

// Root and last QSO in the qso-list
extern struct qso *firstqso;
extern struct qso *lastqso;

// Root and last square in worked-square-list
extern struct squareinfo *firstsquare;
extern struct squareinfo *lastsquare;

// Header of read contest-file
extern struct header h;


extern unsigned char pref_not_found;
extern unsigned char countries;
extern unsigned invalid;



unsigned char load_call_index();
//struct multi_index far *load_multi_index(unsigned *);
//struct loc_index far *load_locator_index(unsigned *);

void read_entry(FILE *, struct callinfo *);

char check_call_and_locator(pchar, pchar);
void make_norm_call(pchar, pchar);
void open_contest_file(pchar,pchar);
uchar read_contest_info(pchar);
struct qso *find_locator(pchar);
uchar write_contest_file(pchar,struct header *, pchar);
struct qso *find_qso(pchar);
void add_qso(struct qso);
void kill_all_prefixes(void);
void kill_all_calls(void);
BOOL find_station(pchar call, struct callinfo *call_rec);
struct countryinfo *find_prefix(pchar call);
void load_prefixes(void);
void kill_all_qso(void);
void kill_all_squares(void);
struct squareinfo *find_square(pchar);
struct squareinfo *add_square(pchar);
void splitcall(pchar,pchar,pchar,pchar);
void query_qso_mask(struct qso_mask *);
char qso_match(struct qso *, struct qso_mask *);

#endif

