
// FIVENINE.C - Kontest-Logging in Perfektion!
// Written by Stefan Pfeiffer, DL1ELY, 940213
// Last Modification: 960222
// (C) 1994, 1995 by Stefan Pfeiffer, DL1ELY


#include "fivenine.h"


// Wird gerade der Bildschirm-Save-Scroll gemacht?
BOOL scroll = 0;

// QRV-auf-Infos anzeigen?
BOOL show_qrv_info = 1;

// Port des Rotor-Interface
char rotor;
// Endanschlag des Rotors
unsigned rotor_ende;

// Sollen unerfahrene Benutzer besonders behandelt werden?
BOOL stupid_user;

// Ist das aktuelle Rufzeichen komplett?
BOOL call_incomplete;

// Koordinaten der eigenen Station in Grad
double own_east;
double own_north;

// Momentan eingegebenes QSO
struct qso actual_qso;
// Momentan geloggter Prfix
struct countryinfo *actual_prefix;

// Momentan geloggter Locator
BOOL locator_state = NO_LOC;
struct squareinfo *actual_square;

// SSB, CW oder AURora?
BOOL qso_mode;


// Farben
uchar textcol;
uchar invcol;
uchar titlecol;
uchar menucol;
uchar menuinvcol;
uchar activebuttoncol;
uchar passivebuttoncol;
uchar numbercol;


// Programm beenden?
BOOL shutdown = FALSE;


// Soll die Zeit des aktuellen QSOs automatisch angepasst werden?
// 0 = automatisch anpassen
// 1 = Festhalten wegen RST-Eingabe
// 2 = Festhalten wegen manueller Eingabe
BOOL fixtime = 0;

// Variablen fr die systeminterne Zeit
uchar hour;
uchar min = 61;
uchar sec = 61;

// Prfix, Kerncall und Erweiterung des Calls
uchar pref[4];
uchar call[14];
uchar add[3];

// Suchmuster fr QSO-Liste
uchar pattern[21];

// Name des CNT-Files
uchar cntname[128];

// Variablen fr Inaktivitt
BOOL do_scrolling;
pchar scp;
uchar scroll_text[81];

unsigned long *sys_timer;
unsigned long old_timer;
unsigned long last_key;
unsigned inact_time;

// ASCII-Zeichen fr Richtungsanzeige (Im Uhrzeigersinn im Norden beginnend)
uchar pointers[9] = { 24, 20, 26, 21, 25, 22, 27, 23, 250 };

// einfgen oder berschreiben?
BOOL do_insert = FALSE;

// Soundausgabe Ja/Nein?
BOOL do_sound;
uchar success_file[128];
uchar double_file[128];
uchar alarm_file[128];
uchar start_file[128];

// Sollen gltige QSOs automatisch gespeichert werden?
BOOL qso_autosave;

// Modus fr 800x600x16 auf VGA-Karten (0 = AUS)
uchar svgamode;

// Soll das Blinken-Attribut auf EGA/VGA benutzt werden?
BOOL do_blink;


// Einstellungen fr Speichernutzung
//extern unsigned char use_ems;
//extern unsigned char use_xms;
unsigned char use_umb = 1;

// Directory von FIVENINE.EXE
uchar fn_path[128];

// Kontestbeschreibung
uchar title[80];
// Datum
uchar date[20];
// Name des *.DES-Files
uchar defname[128];
struct definition *actual_def;

// Vorhersagedaten
unsigned pred_cnt;
unsigned qso_data[48];
unsigned point_data[48];



// Eingabemodus...
#define REALTIME 1
#define POSTTIME 2
unsigned char input_mode = REALTIME;


// Sollen Statistiken mit Balken oder Flchen ausgegeben werden?
BOOL do_bar_stat;

// Grenze, ab der eine Sicherheitsabfrage bei der Locatoreingabe erfolgt.
unsigned checkloc=0;

// Nummer des Druckers
uchar printport = 1;
unsigned char printer_type;

// Rufzeichen von Operator und Logger
uchar op_call[7];
uchar log_call[7];




// Speichert die bandabhngigen Daten in der definition-Struktur
void disable_band(struct definition *def)
{
   def->h = h;
   //def->inputline = line;
   //def->xcur = cpos;
   def->act_qso = actual_qso;
   def->call_incomplete = call_incomplete;
   def->act_prefix = actual_prefix;
   def->act_square = actual_square;
   def->loc_state = locator_state;
   def->qso_mode = qso_mode;
   def->fixtime = fixtime;
   strcpy(def->pattern,pattern);
  
   def->first_square = firstsquare;
   def->last_square = lastsquare;
   def->first_pref = firstcountry;
   def->last_pref = lastcountry;

   kill_all_qso();
};

// Ldt die bandabhngigen Daten aus einer definition-Struktur
void enable_band(struct definition *def, unsigned load)
{
   FILE *f;
   struct qso load_qso;
   void *save;
   unsigned cnt,schwelle;

   h = def->h;
   //line = def->inputline;
   //cpos = def->xcur;
   actual_qso = def->act_qso;
   call_incomplete = def->call_incomplete;
   actual_prefix = def->act_prefix;
   actual_square = def->act_square;
   locator_state = def->loc_state;
   qso_mode = def->qso_mode;
   fixtime = def->fixtime;
   strcpy(pattern,def->pattern);
   strcpy(cntname,def->fname);

   firstsquare = def->first_square;
   lastsquare = def->last_square;
   firstcountry = def->first_pref;
   lastcountry = def->last_pref;
 
   if(load)
   {
      error_log("enable_band()","Start loading...");
      f = fopen(cntname,"rb");
      fseek(f,HEADER_SIZE,SEEK_SET);
  
      save = make_win(10,5,70,10,menucol);
  
      dprintf(35-(strlen(def->band)>>1),6,menucol,"read QSOs: %s",def->band);
      
      cnt = 0;
      init_bar(9,menucol,h.qso_cnt);

      error_log("enable_band()","Reading QSOs");
      while(load_next_qso(f,&load_qso))
      {
         paint_bar(cnt);
         cnt++;
         add_qso(load_qso);
      };
  
      error_log("enable_band()","Reading OK!");
      drestore(save);
      sec_free(save);
      fclose(f);
   };

   hour = 25;
   min = 61;
  
   loc2coord(h.ownloc,&own_east,&own_north);
   error_log("enable_band()","Repainting...");
   repaint();
};  


void load_prediction_data()
{
   FILE *f;
   char s[128];


   generate_path(fn_path,STN_DATA_NAME,"",s);
   f = fopen(s,"rb");

   if(!f)
   {
      memset(point_data,0,sizeof(point_data));
      memset(qso_data,0,sizeof(qso_data));
      pred_cnt = 0;
      return;
   };

   fread(&pred_cnt,1,2,f);
   fread(point_data,1,sizeof(point_data),f);
   fread(qso_data,1,sizeof(qso_data),f);

   fclose(f);
};


// Zeigt die Punkte/QSO-Schtzung fr 24h-Konteste an.
void disp_result_prediction()
{
   unsigned pqsos;
   unsigned long ppoints;
   unsigned char pos;


   if(input_mode == REALTIME)
   {
      if(hour<14) pos = 20+(hour<<1);
      else pos = (hour-14)<<1;
      if(min>=30) pos++;
   }
   else
   {
      if(lastqso)
      {
         if(lastqso->hour<14) pos = 20+(lastqso->hour<<1);
         else pos = (lastqso->hour-14)<<1;
         if(lastqso->min>=30) pos++;
      }
      else pos = 0;
   };
   pos++;

   pqsos = h.qso_cnt;
   ppoints = h.points;

   ppoints = ((float)ppoints/point_data[pos])*0xFFFFL;
   pqsos = ((float)pqsos/qso_data[pos])*0xFFFF;

   dprintf(60,7,titlecol,"%6ld",ppoints);
   dprintf(70,7,titlecol,"%4d",pqsos);
};


// zeigt die Statistik der letzten vollen Stunde an
void display_last_hour()
{
   struct qso *q;
   uchar qsos = 0;
   unsigned punkte = 0;
   int prev_hour;

   prev_hour = hour-1;
   if(prev_hour < 0) prev_hour = 23;

   q = lastqso;
   while(q)
   {
      if((q->hour == hour) || ((q->hour == prev_hour) && (q->min > min)))
      {
         qsos++;
         punkte+=q->points;
         q = q->prev;
      }
      else q = NULL;
   };

   dfill(11,7,14,7,' ',titlecol);
   dprintf(11,7,titlecol,"%3u",qsos);
   dfill(20,7,24,7,' ',titlecol);
   dprintf(20,7,titlecol,"%5u",punkte);
   dfill(33,7,35,7,' ',titlecol);
   dprintf(33,7,titlecol,"%3u",qsos?punkte/qsos:0);
   
   disp_result_prediction();
};

// Schreibt das angegebene QSO in das File
void write_a_qso(struct qso q,FILE *f)
{
   fwrite((void *)&q.hour,1,2,f);
   fwrite((void *)&q.min,1,2,f);
   fwrite((void *)&q.nr,1,2,f);
   fwrite((void *)q.barecall,1,13,f);
   fwrite((void *)q.call,1,14,f);
   fwrite((void *)q.locator,1,7,f);
   fwrite((void *)q.rst_RX,1,8,f);
   fwrite((void *)q.rst_TX,1,4,f);
   fwrite((void *)&q.points,1,2,f);
   fwrite((void *)&q.direction,1,2,f);
};


// Berechnet aus einer Gradangabe den entsprechenden Richtungspfeil
uchar get_dir_pointer(unsigned direction)
{
   // Wenn die Richtung > 360 ist, muss es Nahbereich sein
   if(direction > 360) return(pointers[8]);

   // Auf EGA/VGA wird eine Auflsung von 45 benutzt
   if((graphics == EGA)||(graphics ==VGA))
   {
      // 22.5 addieren, auf berlauf achten, dann dividieren
      direction+=22;
      if(direction >= 360) direction-=360;
      return(pointers[(unsigned)direction/45]);
   }
   else
   {
      // Auf anderen Grafikkarten werden nur 90 aufgelst
      // 45 addieren, auf berlauf achten, dann dividieren
      direction+=45;
      if(direction >= 360) direction-=360;
      // Entsprechende Pfeile zurckgeben
      switch((unsigned)direction/90)
      {
         case 0:
            return(24);
        case 1:
           return(26);
        case 2:
           return(25);
        case 3:
           return(27);
      }
   }
   return(32);
}

// Diese Funktion liefert zu einer Uhrzeit die Minuten, die seit Kontest-
// beginn vergangen sind.
unsigned time2min(uchar hour, uchar min)
{
   if(hour<14)
   {
      return((60*10)+(hour*60)+min);
   }
   else
   {
      return(((hour-14)*60)+min);
   };
};

// "Rt" den richtigen Locator, wenn die Form "99XX" gegeben ist.
// Diese Funktion geht die 9 Grstfelder durch, die um das eigene Grtfeld liegen
// (Inklusive dieses Grtfeld), und sucht denjenigen Locator mit der geringsten
// Entfernung heraus.
void guess_locator(pchar org, pchar new_str)
{
   unsigned min_qrb = 60000;
   uchar min_big[3];
   uchar loc[7];
   uchar i, j;
   double east, north;
   double dist, dir;

   min_big[2] = 0;
   for(i=h.ownloc[0]-1;i<h.ownloc[0]+3;i++)
      for(j=h.ownloc[1]-1;j<h.ownloc[1]+3;j++)
      {
         loc[0] = i;
         loc[1] = j;
         loc[2] = 0;
         strcat(loc,org);
         loc2coord(loc,&east,&north);
         if(strcmp(h.ownloc,loc)) dist_and_dir(own_east,own_north,east,north,&dist,&dir);
         else dist = 3;
         if((unsigned)dist < min_qrb)
         {
            min_qrb = (unsigned)dist;
            min_big[0] = loc[0];
            min_big[1] = loc[1];
         };
      };
   strcpy(new_str,min_big);
   strcat(new_str,org);
};


// Richtet den Locator so ein, da er zum Call passt, und gibt den "korrigierten"
// Locator in loc2 zurck.
void adjust_locator(pchar call, pchar loc1, pchar loc2, BOOL self_adjust)
{
   uchar pref[5];
   uchar ncall[15];
   uchar add[5];
   struct countryinfo *country;
   pchar cp;
   unsigned best_qrb;
   double east, north;
   double dir, dist;
   uchar s[7];
   uchar val1, val2;
   struct qso *qsop;
   uchar hlp[80];


   strcpy(loc2,loc1);

   splitcall(call,pref,ncall,add);

   if(pref[0]) country = find_prefix(pref);
   else country = find_prefix(ncall);

   if(!country) return;

   cp = country->valid_squares;
   best_qrb = 65000;
   val1 = (((*(loc1+2)-'0')*10)+(*(loc1+3)-'0'));

   do
   {
      while((*cp == ' ') && *cp) cp++;
      if(*cp)
      {
         memcpy(s,cp,4);
         s[4] = 0;
         cp+=4;
         val2 = (((s[2]-'0')*10)+(s[3]-'0'));

         if(val1 == val2)
         {
            s[4] = *(loc1+4);
            s[5] = *(loc1+5);
            s[6] = 0;
            loc2coord(s,&east,&north);
            dist_and_dir(own_east,own_north,east,north,&dist,&dir);

            if(dir<best_qrb)
            {
               strcpy(loc2,s);
               best_qrb = dist;
            };
         };
      };
   } while(*cp);


   if(!strcmp(loc1,loc2) || (!self_adjust)) return;

   // Winkel und Entfernung berechnen
   loc2coord(loc2,&east,&north);
   dist_and_dir(own_east,own_north,east,north,&dist,&dir);

   // Locator in Datenzeile eintragen und in aktuelles QSO kopieren
   dprint(46,2,invcol,loc2);
   strcpy(actual_qso.locator,loc2);

   // Enfernung kaufmnnisch runden (0.5 Punkte addieren, dann Nachkommateil abschneiden
   actual_qso.points = (unsigned)(dist+0.5);
   dprint(52,2,textcol,"  ");
   dprintf(56,2,textcol,"%4d",actual_qso.points);
  
   // Richtung eintragen
   actual_qso.direction = (unsigned)dir;
   dprintf(67,2,textcol,"%03d",actual_qso.direction);

   // Richtungspfeil anzeigen
   dprintf(72,2,textcol,"%c",get_dir_pointer(actual_qso.direction));
  
   // Locator-Sicherheitsabfrage
   if(checkloc)
   {
      if(actual_qso.points>=checkloc)
      {
         sprintf(hlp,"Distance >= %dkm! Locator %s correct?",checkloc,actual_qso.locator);
         if(!yes_no_box("Confirmation",hlp))
         {
            actual_qso.locator[0] = 0;
            actual_qso.points = 0;
            actual_qso.direction = 0;
            dfill(46,2,51,2,' ',invcol);
            dprint(52,2,textcol,"  ");
            dfill(57,3,67,3,' ',textcol);
            dfill(45,3,56,3,' ',textcol);
            dprint(56,2,textcol,"    ");
            dprint(67,2,textcol,"   ");
            dprint(72,2,textcol," ");
            return;
         };
      };
   };

   dprint(57,3,textcol,"          ");
   // Neues ODX?
   if(actual_qso.points > h.ODX)
   {
     dprint(57,3,textcol,"New ODX!  ");
     switch(do_sound)
     {
        case 0:
           break;
        case 1:
           sound(1200);
           delay(250);
           nosound();
           break;
        case 2:
           if(playwave(success_file))
           {
              do ;
              while(!play_end());
              end_wave();
           };
           break;
      };
   };

   // Grofeld in Liste suchen
   actual_square = find_square(loc2);
   dprint(45,3,textcol,"           ");
   // Neues Feld?
   if(!actual_square)
   {
     dprint(45,3,textcol,"New square!");
     switch(do_sound)
     {
        case 0:
           break;
        case 1:
           sound(1200);
           delay(250);
           nosound();
           break;
        case 2:
           if(playwave(success_file))
           {
              do ;
              while(!play_end());
              end_wave();
           };
           break;
      }
   };

   // Schon QSO mit diesem Locator gehabt? Anzeigen...
   qsop = find_locator(loc2);
   if(qsop)
   {
      strcpy(pattern,loc2);
      print_qso(pattern,0);
   };

   dprint(52,2,textcol,"  ");

   return;
};



// Verarbeitet den bergebenen Locator
void calc_loc(pchar s)
{
   double north;
   double east;
   double distance;
   double direction;
   struct qso *qsop;
   uchar hlp[80];
   uchar loc[7];
   uchar slen;

   slen = strlen(s);
   if(slen==6) strcpy(loc,s);
   else
   {
      if(slen == 4)
      {
         guess_locator(s,loc);
         locator_state = GUESS_LOC;
      }
      else
      {
         if(actual_qso.locator[0]) memcpy(loc,actual_qso.locator,6-slen);
         else memcpy(loc,h.ownloc,6-slen);
         *(loc+6-slen) = 0;
         strcat(loc,s);
         locator_state = GUESS_LOC;
      };
   };

   strcpy(hlp,loc);
   if((actual_qso.call[0]) && (!actual_qso.locator[0]) && (locator_state == GUESS_LOC)) adjust_locator(actual_qso.call,hlp,loc,0);

   if(!valid_locator(loc)) return;
  
   // Winkel und Entfernung berechnen
   loc2coord(loc,&east,&north);
   dist_and_dir(own_east,own_north,east,north,&distance,&direction);

   // Locator in Datenzeile eintragen und in aktuelles QSO kopieren
   dprint(46,2,invcol,loc);
   strcpy(actual_qso.locator,loc);

   // Enfernung kaufmnnisch runden (0.5 Punkte addieren, dann Nachkommateil abschneiden
   actual_qso.points = (unsigned)(distance+0.5);
   dprint(52,2,textcol,"  ");
   dprintf(56,2,textcol,"%4d",actual_qso.points);
  
   // Richtung eintragen
   actual_qso.direction = (unsigned)direction;
   dprintf(67,2,textcol,"%03d",actual_qso.direction);

   // Richtungspfeil anzeigen
   dprintf(72,2,textcol,"%c",get_dir_pointer(actual_qso.direction));
  
   // Locator-Sicherheitsabfrage
   if(checkloc)
   {
      if(actual_qso.points>=checkloc)
      {
         sprintf(hlp,"Distance >= %dkm! Locator %s correct?",checkloc,actual_qso.locator);
         if(!yes_no_box("Confirmation",hlp))
         {
            actual_qso.locator[0] = 0;
            actual_qso.points = 0;
            actual_qso.direction = 0;
            dfill(46,2,51,2,' ',invcol);
            dprint(52,2,textcol,"  ");
            dfill(57,3,67,3,' ',textcol);
            dfill(45,3,56,3,' ',textcol);
            dprint(56,2,textcol,"    ");
            dprint(67,2,textcol,"   ");
            dprint(72,2,textcol," ");
            return;
         };
      };
   };

   dprint(57,3,textcol,"          ");
   // Neues ODX?
   if(actual_qso.points > h.ODX)
   {
      dprint(57,3,textcol,"New ODX!  ");
      switch(do_sound)
      {
         case 0:
            break;
         case 1:
            sound(1200);
            delay(250);
            nosound();
            break;
         case 2:
            if(playwave(success_file))
            {
               do ;
               while(!play_end());
               end_wave();
            };
            break;
      };
   };
  
   // Grofeld in Liste suchen
   actual_square = find_square(loc);
   dprint(45,3,textcol,"           ");
   // Neues Feld?
   if(!actual_square)
   {
      dprint(45,3,textcol,"New square!");
      switch(do_sound)
      {
         case 0:
            break;
         case 1:
            sound(1200);
            delay(250);
            nosound();
            break;
         case 2:
            if(playwave(success_file))
            {
               do ;
               while(!play_end());
               end_wave();
            };
            break;
      }
   };

   // Schon QSO mit diesem Locator gehabt? Anzeigen...
   qsop = find_locator(loc);
   if(qsop)
   {
      strcpy(pattern,loc);
      print_qso(pattern,0);
   };

   dprint(52,2,textcol,"  ");
   // Schon Call bekannt?? Dann prfen, ob der Locator zum
   // Prfix passt.
   if(actual_qso.call[0])
   {
      if(check_call_and_locator(actual_qso.call,loc) == CHK_WRONG_SQUARE)
      {
         dprint(52,2,numbercol,"??");
         switch(do_sound)
         {
            case 0:
               break;
            case 1:
               sound(100);
               delay(600);
               nosound();
               break;
            case 2:
               if(playwave(alarm_file))
               {
                  do ;
                  while(!play_end());
                  end_wave();
               };
               break;
         };
         if(stupid_user) ok_box("Mistake in locator","The locator is likely to be wrong!");
      };
   };

   *s = 0;
};


// berprft, ob der String s eine gltige Uhrzeit enthlt
// Stunde und Minute mssen durch ein ':' getrennt sein
BOOL valid_time(pchar s)
{
   pchar sep, cp;
   uchar hour, minute;

   // Doppelpunkt suchen
   sep = strchr(s,':');
   // Kein Doppelpunkt gefunden -> gltig?
   if(!sep)
   {
      // Eingabe mu 4stellig sein!
      if(strlen(s) == 4)
      {
         // Es drfen nur Zahlen vorhanden sein!
         for(hour = 0; (hour < 4) && isdigit(*(s+hour)) ; hour++) ;
         if(hour==4)
         {
            hour = ((*s-'0')*10)+(*(s+1)-'0');
            minute = ((*(s+2)-'0')*10)+(*(s+3)-'0');
            if((hour<24) && (minute<60)) return(1);
         };
      };
      // ungltig!
      return(0);
   };

   // Mehr als 2 Zeichen vor dem Doppelpunkt -> ungltig
   if(sep-s > 2) return(0);
   // Vor und nach dem Doppelpunkt drfen nur Zahlen stehen!
   for(cp=s;cp < sep;cp++) if(!isdigit(*cp)) return(0);
   for(cp=sep+1;*cp;cp++) if(!isdigit(*cp)) return(0);
   // Nach dem Doppelpunkt drfen hchstens 2 Zeichen stehen!
   if(cp-sep > 3) return(0);
   // Ja, es ist eine gltige Zeitangabe
   return(1);
};


// Extrahiert aus einem gltigen String die Stunde und Minute
void parse_time(pchar s, pchar h, pchar m)
{
   pchar cp;

   // Doppelpunkt suchen, durch 0 ersetzen, dann Strings in Zahlen wandeln
   cp = strchr(s,':');
   if(!cp)
   {
      *h = ((*s-'0')*10)+(*(s+1)-'0');
      *m = ((*(s+2)-'0')*10)+(*(s+3)-'0');
      return;
   };

   *cp = 0;
   cp++;
   *h = atoi(s);
   *m = atoi(cp);
};

// Bearbeitet den gltigen Zeit-String s
void do_time(pchar s)
{
   // Stunde und Minute extrahieren und auf Gltigkeit prfen
   parse_time((pchar)s,(pchar)&actual_qso.hour,(pchar)&actual_qso.min);
   if(actual_qso.hour>23) return;
   if(actual_qso.min>59) return;
   // Festhalten der Zeit wegen manueller Eingabe
   fixtime = 2;
   dprintf(2,2,invcol,"%02d:%02d",actual_qso.hour,actual_qso.min);
};


// Lscht eine Zeile im QSO-Listen-Bereich und schreibt die Trennstriche
void print_empty_line(uchar line)
{
   dfill(0,line,lastrow,line,' ',textcol);
   dprint(5,line,textcol,"\263");
   dprint(19,line,textcol,"\263");
   dprint(27,line,textcol,"\263");
   dprint(35,line,textcol,"\263");
   dprint(42,line,textcol,"\263");
   dprint(47,line,textcol,"\261");
};

// Gibt die Daten des QSOs *qsop in der Zeile i im QSO-Listen-Bereich aus
void print_qso_line(struct qso *qsop, uchar i)
{
   dprintf(0,i,textcol,"%02u:%02u",qsop->hour,qsop->min);
   dprintf(6,i,textcol,"%-13s",qsop->call);
   dprintf(20,i,textcol,"%3s",qsop->rst_TX);
   if(qsop->nr < 1000) dprintf(24,i,textcol,"%03u",qsop->nr);
   else dprintf(23,i,textcol,"%04u",qsop->nr);
   dprintf(28,i,textcol,"%7s",qsop->rst_RX);
   dprintf(36,i,textcol,"%6s",qsop->locator);
   if(qsop->points) dprintf(43,i,textcol,"%4u",qsop->points);
      else dprint(43,i,textcol," ***");
};

// Gibt die letzen QSOs im QSO-Listen-Bereich aus, auf die das Suchmuster
// passt (Call, Kerncall oder Locator)
void print_qso(pchar pattern, BOOL call_only)
{
   struct qso *qsop;
   uchar i;
   pchar argv[20];
   uchar result;
   uchar j;

   i = lastline-1;
   qsop = lastqso;

   while(qsop && i > 8)
   {
      memset(argv,0,20*sizeof(pchar));
      // * bedeutet: alle QSOs anzeigen
      if(!strcmp(pattern,"*")) result = 1;
      else
      {
         result = wildmat((char *)qsop->call,(char *)pattern,(char **)argv);
         for(j = 0;argv[j] != NULLchar;++j) sec_free(argv[j]);
      }

      if(!result)
      {
         result = wildmat((char *)qsop->barecall,(char *)pattern,(char **)argv);
         for(j = 0;argv[j] != NULLchar;++j) sec_free(argv[j]);
      }

      if((!result) && (!call_only))
      {
         result = wildmat((char *)qsop->locator,(char *)pattern,(char **)argv);
         for(j = 0;argv[j] != NULLchar;++j) sec_free(argv[j]);
      }

      // QSO ausgeben?
      if(result)
      {
         print_empty_line(i);
         print_qso_line(qsop,i);
         i--;
      }
      qsop = qsop->prev;
   }

   // Evtl. leergebliebene Zeilen lschen
   while(i > 8)
   {
      print_empty_line(i);
      i--;
   }
   dprint(59,6,titlecol,"\263");
   dprintf(61,6,titlecol,"%-15s",pattern);
}


void do_add(pchar cp)
{
   uchar prefix[5];
   uchar call[10];
   uchar suffix[4];
   uchar help[20];

   cp++;   // '/' berspringen

   if(strlen(cp)>2) return;

   if(call_incomplete == CALL_MISS)
   {
      help[0] = 0;
      splitcall(actual_qso.call,prefix,call,suffix);
      if((!strcmp(suffix,cp)) && (!prefix[0]))
      {
         prefix[0] = 0;
         suffix[0] = 0;
         *cp = 0;
         dfill(10,2,24,2,' ',invcol);
         actual_qso.barecall[0] = 0;
         actual_qso.call[0] = 0;
         return;
      };

      if(prefix[0]) sprintf(help,"%s/",prefix);
      strcat(help,"??????");
      if(suffix[0])
      {
         strcat(help,"/");
         strcat(help,suffix);
      };
      strcpy(actual_qso.barecall,"??????");
      strcpy(actual_qso.call,help);
   };

   splitcall(actual_qso.call,prefix,call,suffix);

   if(!*call) return;

   if(strcmp(suffix,cp))
      strcpy(suffix,cp);
   else
     suffix[0] = 0;

   help[0] = 0;
   if(*prefix) sprintf(help,"%s/",prefix);
   strcat(help,call);
   if(*suffix)
   {
      strcat(help,"/");
      strcat(help,suffix);
   }

   dfill(10,2,24,2,' ',invcol);
   dprint(10,2,invcol,help);
   strcpy(actual_qso.call,help);
};


// Checks if input is a valid suffix
BOOL valid_suffix(pchar s)
{
   pchar cp;
   uchar pos;

   if(*(s+strlen(s)-1) == '/') return(0);
   pos = 0;
   while(s[pos] && s[pos]!='/') pos++;
   if(pos > 4) return(0);

   if(s[1] == '/') return(0);
   cp = s;
   while(isalpha(*cp) && *cp && *cp != '/') cp++;
   if(*cp && (*cp!='/')) return(0);
   if(isdigit(*(s+strlen(s)-1))) return(0);
   if(strlen(cp) > 3) return(0);

   return(1);
};

// Bearbeitet einen als gltig erkannten Suffix
void do_suffix(pchar s)
{
   pchar cp;
   uchar pref[5];
   uchar add[4];
   uchar newcall[14];
   uchar dummy[14];
   struct qso *qsop;
   pchar addp;

   addp = s;
   while(*addp && *addp!='/') addp++;
   if(*addp)
   {
      *addp = 0;
      addp++;
   };

   if(call_incomplete == CALL_COMPLETE)
   {
      strcpy(newcall,actual_qso.barecall);
      cp = newcall+strlen(newcall);
      while(!isdigit(*cp)) cp--;
      cp++;
      strcpy(cp,s);

      splitcall(actual_qso.call,pref,dummy,add);
      do_call(pref,newcall,*addp?addp:add);
   };

   if(call_incomplete == SUFFIX_MISS)
   {
      strcpy(newcall,actual_qso.barecall);
      cp = newcall;
      while(*cp != '?') cp++;
      strcpy(cp,s);

      splitcall(actual_qso.call,pref,dummy,add);
      do_call(pref,newcall,*addp?addp:add);
      call_incomplete = CALL_COMPLETE;
   };

   if((call_incomplete == PREFIX_MISS) || (call_incomplete == CALL_MISS))
   {
      splitcall(actual_qso.call,pref,dummy,add);
      if(*addp) strcpy(add,addp);

      sprintf(actual_qso.barecall,"???%s",s);
      newcall[0] = 0;
      if(pref[0]) sprintf(newcall,"%s/",pref);
      strcat(newcall,actual_qso.barecall);
      if(add[0])
      {
        strcat(newcall,"/");
        strcat(newcall,add);
      };
      strcpy(actual_qso.call,newcall);

      dfill(10,2,24,2,' ',invcol);
      dprint(10,2,invcol,newcall);
      call_incomplete = PREFIX_MISS;
   };

   qsop = firstqso;
   while(qsop && (!strstr(qsop->barecall,s))) qsop = qsop->next;

   if(qsop)
   {
      sprintf(pattern,"*%s*",s);
      print_qso(pattern,1);
   };
};


// Prft, ob s ein gltiger Prfix ist
BOOL valid_prefix(pchar s)
{
   pchar cp1, cp2;
   unsigned slen;
   uchar str[20];

   if(*(s+strlen(s)-1) == '/') return(1);

   strcpy(str,s);
   cp1 = str;
   while(*cp1 && *cp1!='/') cp1++;
   if(*cp1)
   {
     *cp1 = 0;
     cp1++;
   }
   else cp1 = str;

   slen = strlen(cp1);
   if(slen>5) return(0);

   cp2 = cp1+slen-1;

   if(!isdigit(*cp2)) return(0);

   cp2 = cp1;
   while(!isalpha(*cp2) && *cp2) cp2++;
 
   return(*cp2);
};

// Bearbeitet einen als gltig erkannten Prfix
void do_prefix(pchar s)
{
   pchar cp, cp2;
   uchar newcall[14];
   uchar pref[5];
   uchar dummy[14];
   uchar add[4];
   struct countryinfo *prefix;

   cp = s;
   while(*cp && *cp!='/') cp++;
   if(*cp && *(cp+1))
   {
      *cp = 0;
      cp++;
   }
   else cp = s;

   cp2 = cp+strlen(cp)-1;
   if(*cp2 == '/')
   {
      *cp2 = 0;
      if(call_incomplete == CALL_COMPLETE)
      {
         splitcall(actual_qso.call,pref,newcall,add);
         if(!strcmp(pref,cp))
         {
            strcpy(actual_qso.call,newcall);
            if(add[0])
            {
               strcat(actual_qso.call,"/");
               strcat(actual_qso.call,add);
            };
            do_call("\0",newcall,add);
         }
         else do_call(cp,newcall,add);
         return;
      };

      splitcall(actual_qso.call,pref,dummy,add);
      if(!strcmp(pref,cp))
      {
         if(call_incomplete == CALL_MISS && !add[0])
         {
            actual_qso.barecall[0] = 0;
            actual_qso.call[0] = 0;
            *cp = 0;
         };

         strcpy(newcall,actual_qso.barecall);
         if(add[0])
         {
            strcat(newcall,"/");
            strcat(newcall,add);
         };
      }
      else
      {
         sprintf(newcall,"%s/%s",cp,actual_qso.barecall[0]?actual_qso.barecall:"??????");
         if(add[0])
         {
            strcat(newcall,"/");
            strcat(newcall,add);
         };
      };
      dfill(10,2,24,2,' ',invcol);
      dprint(10,2,invcol,newcall);
      strcpy(actual_qso.call,newcall);
   }
   else
   {
      if(call_incomplete == CALL_COMPLETE)
      {
         strcpy(dummy,actual_qso.barecall);
         cp2 = dummy+strlen(dummy)-1;
         while(!isdigit(*cp2)) cp2--;
         cp2++;

         strcpy(newcall,s);
         strcat(newcall,cp2);

         splitcall(actual_qso.call,pref,dummy,add);
         do_call(cp!=s?s:pref,newcall,add);
         return;
      };

      if(call_incomplete == PREFIX_MISS)
      {
         strcpy(newcall,cp);
         cp2 = actual_qso.barecall;
         while(*cp2 == '?') cp2++;
         strcat(newcall,cp2);

         splitcall(actual_qso.call,pref,dummy,add);
         do_call(cp!=s?s:pref,newcall,add);
         call_incomplete = CALL_COMPLETE;
      };
 
      if((call_incomplete == SUFFIX_MISS) || (call_incomplete == CALL_MISS))
      {
         splitcall(actual_qso.call,pref,dummy,add);
         if(cp!=s) strcpy(pref,s);
         sprintf(actual_qso.barecall,"%s???",cp);
         newcall[0] = 0;
         if(pref[0]) sprintf(newcall,"%s/",pref);
         strcat(newcall,actual_qso.barecall);
         if(add[0])
         {
            strcat(newcall,"/");
            strcat(newcall,add);
         };
         strcpy(actual_qso.call,newcall);

         dfill(10,2,24,2,' ',invcol);
         dprint(10,2,invcol,newcall);
         call_incomplete = SUFFIX_MISS;
      };
   };

   dfill(2,3,44,3,' ',textcol);
   if(actual_qso.barecall[0] && actual_qso.barecall[0]!='?')
   {
      splitcall(actual_qso.call,pref,call,add);
      if(*pref) prefix = find_prefix(pref);
      else prefix = find_prefix(call);

      if(prefix)
      {
         if(prefix->worked) dprint(10,3,textcol,prefix->name_eng);
         else dprintf(10,3,textcol,"NEW:%s",prefix->name_eng);
      }
      else dprint(10,3,textcol,"Unknown prefix!    ");
   };
};


/* Inserts the given call in the actual qso */
void do_call(pchar pref,pchar call,pchar add)
{
   uchar help[15];
   struct qso *doubleqso;
   struct callinfo stn_info;
   pchar cp;
   uchar dummy[14];
   uchar s[80];
   uchar p[5];
   uchar a[4];
   uchar i;
   BOOL result;
   uchar loc[7];

   // Untersttzte Bnder
   char band[][16] =
   {
      "50 MHz" , "70 MHz" , "144 MHz", "432 MHz", "1,3 GHz", "2,3 GHz",
      "3,4 GHz", "5,7 GHz", "10 GHz" , "24 GHz" , "47 GHz" , "76 GHz" ,
      "120 GHz", "144 GHz", "248 GHz", "---"
   };


   if(strlen(pref)>3) return;

   if(actual_qso.call[0])
   {
      splitcall(actual_qso.call,p,dummy,a);
      if(!*pref) pref = p;
      if(!*add) add = a;
   };

   if(*pref)
   {
      // Im Prefix muss mindestens 1 Buchstabe enthalten sein!
      cp = pref;
      while(*cp&&isdigit(*cp)) cp++;
      if(!*cp) return;
   };

   // Letztes Zeichen des Calls muss ein Buchstabe sein!
   if(!isalpha(call[strlen(call)-1])) return;
   // Im Call muss mindestens eine Ziffer enthalten sein!
   cp = call;
   while(*cp&&isalpha(*cp)) cp++;
   if(!*cp) return;

   help[0] = 0;
   if(*pref) sprintf(help,"%s/",pref);
   strcat(help,call);
   if(*add)
   {
      strcat(help,"/");
      strcat(help,add);
   }

   dfill(10,2,24,2,' ',invcol);
   dprint(10,2,invcol,help);
   strcpy(actual_qso.call,help);
   strcpy(actual_qso.barecall,call);
   call_incomplete = CALL_COMPLETE;

   if(*pref) actual_prefix = find_prefix(pref);
      else actual_prefix = find_prefix(call);

   dfill(2,3,44,3,' ',textcol);
   if(actual_prefix)
   {
      if(actual_prefix->worked) dprint(10,3,textcol,actual_prefix->name_eng);
      else
      {
         dprintf(10,3,textcol,"NEW:%s",actual_prefix->name_eng);
         switch(do_sound)
         {
            case 0:
               break;
            case 1:
               sound(1200);
               delay(250);
               nosound();
               break;
            case 2:
               if(playwave(success_file))
               {
                  do ;
                  while(!play_end());
                  end_wave();
               };
               break;
         };
      };
   }
   else
   {
      dprint(10,3,textcol,"Unknown prefix!    ");
      switch(do_sound)
      {
         case 0:
            break;
         case 1:
            sound(100);
            delay(600);
            nosound();
            break;
         case 2:
            if(playwave(alarm_file))
            {
               do ;
               while(!play_end());
               end_wave();
            };
            break;
      }
      if(stupid_user) ok_box("Mistake in prefix","The entered prefix is unknown. Please check it.");
   };
  
   if(locator_state == DB_LOC)
   {
      actual_qso.locator[0] = 0;
      actual_square = NULLsquare;
      dfill(46,2,51,2,' ',invcol);
      dprint(56,2,textcol,"    ");
      dprint(67,2,textcol,"   ");
      dprint(72,2,textcol," ");
      dfill(45,3,lastrow,3,' ',textcol);
      locator_state = NO_LOC;
   }

   doubleqso = find_qso(call);
   if(doubleqso)
   {
      dfill(2,3,68,3,' ',textcol);
      dprintf(10,3,textcol,"Worked before!");
      strcpy(pattern,doubleqso->barecall);
      print_qso(pattern,1);
      switch(do_sound)
      {
         case 0:
            break;
         case 1:
            sound(100);
            delay(600);
            nosound();
            break;
         case 2:
            if(playwave(double_file))
            {
               do ;
               while(!play_end());
               end_wave();
            };
            break;
      }
      if(stupid_user)
      {
        sprintf(s,"Station %s has been logged before!",doubleqso->call);
        ok_box("Dupe-QSO",s);
      };
   }
   else
   {
      //dfill(0,6,lastrow,6,' ',textcol);
      strcpy(dummy,actual_qso.call);
      make_norm_call(dummy,dummy);
      result = find_station(dummy,&stn_info);
      if(!result) result = find_station(actual_qso.call,&stn_info);
      if(result)
      {
         //dfill(0,4,68,4,' ',textcol);
         //dprintf(2,4,textcol,"Info: (%s) %s",stn_info.locator,stn_info.info);
         strncpy(loc,stn_info.locator,6);
         loc[6] = 0;

         if(valid_locator(loc) && locator_state != MAN_LOC)
         {
            locator_state = DB_LOC;
            calc_loc(loc);
         };

/*         if((valid>1)&&(show_qrv_info))
         {
            strcpy(s,"QRV on:");
            for(i=0;i<15;i++)
            {
               if(stn_info.qrv_on[i]=='X')
               {
                  strcat(s,"  ");
                  strcat(s,band[i]);
               };
            };
            if(strlen(s)>8) dprint(40-(strlen(s)>>1),6,textcol,s);
         };*/
   
         switch(do_sound)
         {
            case 0:
               break;
            case 1:
               sound(1200);
               delay(250);
               nosound();
               break;
            case 2:
               if(playwave(success_file))
               {
                  do ;
                  while(!play_end());
                  end_wave();
               };
               break;
         }
      }
      else
      {
         //dfill(0,4,68,4,' ',textcol);
         //dprint(2,4,textcol,"Info: ()");
      };
   };

   dprint(52,2,textcol,"  ");
   // Schon Locator bekannt?? Dann prfen, ob der Locator zum
   // Prfix passt.
   if(actual_qso.locator[0])
   {
      if(locator_state == GUESS_LOC)
      {
         strcpy(dummy,actual_qso.locator);
         adjust_locator(actual_qso.call,dummy,actual_qso.locator,1);
      };

      if(check_call_and_locator(actual_qso.call,actual_qso.locator) == CHK_WRONG_SQUARE)
      {
         dprint(52,2,numbercol,"??");
         switch(do_sound)
         {
            case 0:
               break;
            case 1:
               sound(100);
               delay(600);
               nosound();
               break;
            case 2:
               if(playwave(alarm_file))
               {
                  do ;
                  while(!play_end());
                  end_wave();
               };
               break;
         };
         if(stupid_user) ok_box("Mistake in locator","The locator is likely to be wrong!");
      };
   };
};

/* Returns next item to be parsed on command-line */
pchar get_next_item(ppchar cp)
{
   pchar hlp;

   hlp = *cp;
   while(*hlp && (*hlp == ',' || *hlp == ' ')) hlp++;
   *cp = hlp;
   while(*hlp && *hlp != ',' && *hlp != ' ') hlp++;
   if(*hlp)
   {
      *hlp = 0;
      hlp++;
   }
   return(hlp);
};

/* Checks if string s contains an valid RST */
BOOL valid_rst(pchar s)
{
   uchar slen;

   slen = strlen(s);
   switch(qso_mode)
   {
      case MODE_SSB:  // z.B. 59017
         if(slen < 2 || slen > 6) return(0);
         break;

      case MODE_CW:   // z.B. 599017
         if(slen < 3 || slen > 7) return(0);
         break;

      case MODE_AUR:  // z.B. 59A017 oder 57A oder auch 52
         if(slen < 2 || slen > 7) return(0);
         if((slen > 2) && (s[2]!='A')) return(0);
         if(*s > '5') return(0);
         if(!(isdigit(*s)&&isdigit(*(s+1)))) return(0);
         s+=3;
         while(*s && isdigit(*s)) s++;
         return(!*s);
   };

   if(*s > '5') return(0);
   while(*s && isdigit(*s)) s++;
   if(*s == 'S') s++;      
   return(!*s);
};

/* Parse the RST and insert it in the actual_qso */
void do_rst(pchar s)
{
   uchar slen;
   uchar marker;
   uchar rst_rx[4];
   unsigned lnr;
   pchar cp;
   uchar hlp[15];

   marker = (qso_mode == MODE_SSB?2:3);

   slen = strlen(s);
   if((qso_mode == MODE_AUR) && (slen==2))
   {
      sprintf(actual_qso.rst_TX,"%sA",s);
      dprint(28,2,invcol,actual_qso.rst_TX);
      return;
   };

   if(slen == marker)
   {
      if((slen==3)&&(s[2]=='0')) s[2] = 0;
      sprintf(actual_qso.rst_TX,"%3s",s);
      dprint(28,2,invcol,actual_qso.rst_TX);
      return;
   };

   memmove((pchar)rst_rx,(pchar)s,marker);
   rst_rx[marker] = 0;
   if((marker==3) && (rst_rx[2] == '0')) rst_rx[2] = 0;
   cp = (pchar)s+marker;
   lnr = atoi(cp);

   if(lnr < 1000) sprintf(hlp,"%3s %03u",rst_rx,lnr);
   else  sprintf(hlp,"%3s%4u",rst_rx,lnr);
   strcpy(actual_qso.rst_RX,hlp);
   dprint(37,2,invcol,actual_qso.rst_RX);

   if(fixtime < 2)
   {
      fixtime = 1;
      actual_qso.hour = hour;
      actual_qso.min = min;
      dprintf(2,2,invcol,"%02d:%02d",actual_qso.hour,actual_qso.min);
   }
};


/* Updates the time when the user pressed no key */
void updatetime()
{
   struct time t;
   uchar ch;
   uchar type;
   uchar len;
   uchar buf[260];
   static uchar moved = 0;
   struct REGPACK r;

   if((do_scrolling == PERM_SCROLL) ||
      (do_scrolling == SAVE_SCROLL && (*sys_timer-last_key > (int)inact_time*18.2*60)))
      if(*sys_timer > old_timer+2)
      {
         if(!scroll)
         {
            scroll = 1;
            my_gotoxy(80,lastline+1);
            moved = 0;
         };

         old_timer = *sys_timer;
         if(moved<80)
         {
            dmove(1,0,79,lastline,0,0);
            dfill(79,0,79,lastline,' ',BLACK);
            moved++;
            if(80-moved < strlen(scroll_text))
            {
               dprintf(79,0,textcol,"%c",*scp);
               scp++;
            };
         };
   };

   gettime(&t);
   if((t.ti_sec != sec) && (!scroll))
   {
      sec = t.ti_sec;

      r.r_ax = 0x4800;
      r.r_bx = 0xFFFF;
      intr(0x21,&r);
  
      dprintf(72,lastline,titlecol,"%5.1fKB",(double)farcoreleft()/1024);
   }

   if(t.ti_min != min)
   {
      hour = t.ti_hour;
      min = t.ti_min;

      if(!scroll)
      {
         display_last_hour();

         dprintf(73,0,titlecol,"%02u:%02u",hour,min);
         if(!fixtime) dprintf(2,2,invcol,"%02u:%02u",hour,min);
      }
   }
/*
   if(tnc_type == TNC) tnc_poll();

   if(!scroll) comm_output(); */
};


/* Delete the actually entered QSO */
void kill_akt_qso()
{
   uchar hlp[20];

   locator_state = NO_LOC;
   fixtime = 0;

   memset(&actual_qso,0,QSO_SIZE);
   call_incomplete = CALL_MISS;
   switch(qso_mode)
   {
      case MODE_SSB:
         strcpy(hlp," 59");
         break;
      case MODE_CW:
         strcpy(hlp,"599");
         break;
      case MODE_AUR:
         strcpy(hlp,"59A");
         break;
   };

   strcpy(actual_qso.rst_TX,hlp);

   dprintf(2,2,invcol,"%02d:%02d",hour,min);

   dfill(10,2,24,2,' ',invcol);
   dfill(28,2,30,2,' ',invcol);
   dprint(28,2,invcol,actual_qso.rst_TX);
   dfill(37,2,43,2,' ',invcol);
   dfill(46,2,51,2,' ',invcol);

   dprint(52,2,textcol,"        ");
   dprint(67,2,textcol,"   ");
   dprint(72,2,textcol," ");
   dfill(0,3,lastrow,3,' ',textcol);
   //dfill(0,4,68,4,' ',textcol);
   //dprint(2,4,textcol,"Info: ()");
  
   //dfill(0,5,lastrow,5,' ',textcol);

   actual_prefix = NULLcountry;
   actual_square = NULLsquare;
};

/* Inserts the actual qso in the qso-list and saves it */
void save_akt_qso()
{
   struct qso *newqso;
   uchar hlp[20];
   FILE *cntfile;

   if(valid_qso(actual_qso))
   {
      if(fixtime==2) input_mode = POSTTIME;
      else input_mode = REALTIME;
      
      dfill(0,5,lastrow,5,' ',textcol);
      dprint(32,5,textcol,input_mode==REALTIME?"R E A L T I M E - L O G":"P O S T T I M E - L O G");

      actual_qso.nr = h.qso_cnt+1;
      h.qso_cnt++;
      dprintf(38,0,numbercol,"%4d",h.qso_cnt+1);
      if(h.qso_cnt<999) dprintf(32,2,textcol,"%03d",h.qso_cnt+1);
      else dprintf(31,2,textcol,"%4d",h.qso_cnt+1);

      newqso = find_qso(actual_qso.barecall);
      if(newqso)
      {
         actual_qso.points = 0;
         h.invalid++;
      }

      if(actual_qso.points > h.ODX)
      {
         h.ODX = actual_qso.points;
         strcpy(h.ODX_call,actual_qso.call);
      }

      h.points += actual_qso.points;
      h.average = h.points / (h.qso_cnt-h.invalid);

      dcolor(0,6,lastrow,6,titlecol);
      dprintf(1,6,titlecol,"%6lu points\263",h.points);
      dprintf(16,6,titlecol,"%4u km/QSO\263",h.average);
      dfill(29,6,58,6,' ',titlecol);
      dprintf(29,6,titlecol,"%4u km ODX (%s)",h.ODX,h.ODX_call);
      dprint(59,6,titlecol,"\263");
      dprintf(61,6,titlecol,"%-16s",pattern);
    
      splitcall(actual_qso.call,pref,call,add);
      strcpy(actual_qso.barecall,call);
      add_qso(actual_qso);

      if(actual_prefix)
      {
         if(!actual_prefix->worked) h.countries++;
         actual_prefix->worked++;
         actual_prefix->points += actual_qso.points;
      }
      else h.unknown_pref++;

      if(!actual_square)
      {
         actual_square = add_square(actual_qso.locator);
         h.squares++;
      }
      actual_square->worked++;
      actual_square->points += actual_qso.points;

      dprintf(48,0,titlecol,"C:%2u/SQ:%2u",h.countries,h.squares);
      strcpy(pattern,"*");
      print_qso(pattern,0);

      cntfile = fopen(cntname,"r+b");
      fwrite((void *)&h,1,HEADER_SIZE,cntfile);
      fclose(cntfile);

      cntfile = fopen(cntname,"ab");
      write_a_qso(actual_qso,cntfile);
      fclose(cntfile);

      display_last_hour();
   };
};



/* Checks if string s contains a valid pattern */
BOOL valid_pattern(pchar s)
{
   return(*s == '?');
};

/* Processes the pattern given in string s */
void do_pattern(pchar s)
{
   s++;
   strcpy(pattern,s);
   print_qso(pattern,0);
};

// Reads the configurations-file and interprets it
uchar read_config_file()
{
   uchar res;
   pchar s;

   res = read_config(CONFIG_NAME);

   if(!res) return(0);

   svgamode = get_int("SVGA",0);

   s = get_str("QSOMODE");
   qso_mode = MODE_SSB;
   if(!stricmp(s,"CW")) qso_mode = MODE_CW;
   if(!stricmp(s,"AURORA")) qso_mode = MODE_AUR;

   do_bar_stat = get_bool("BARSTATISTICS",1);
   stupid_user = get_bool("NOTIFICATION",0);
 
   textcol    = get_color("TEXTCOLOR",0);
   invcol     = get_color("INVTEXTCOLOR",0);
   titlecol   = get_color("TITLECOLOR",0);
   menucol    = get_color("MENUCOLOR",0);
   menuinvcol = get_color("MENUINVCOLOR",0);
   numbercol  = get_color("NUMBERCOLOR",0);

   activebuttoncol  = get_color("ACTBUTTONCOLOR",0);
   passivebuttoncol = get_color("INACTBUTTONCOLOR",0);

   mapcol     = get_color("MAPCOLOR",0);
   bordercol  = get_color("BORDERCOLOR",0);
   maptextcol = get_color("MAPTEXTCOLOR",0);

   gridcol    = get_color("GRIDCOLOR",0);
   gridinvcol = get_color("GRIDINVCOLOR",0);

   do_scrolling = 1;
   inact_time = get_int("BANNERTIME",5);
   s = get_str("BANNERTEXT");
   strcpy(scroll_text,s);
   if(!inact_time) do_scrolling = 0;

   do_sound = get_int("SOUND",2);
   if((do_sound==2)&&is_windows()) do_sound = 1;

   s = get_str("SUCCESSSOUND");
   generate_path(fn_path,s,".WAV",success_file);
   s = get_str("DOUBLESOUND");
   generate_path(fn_path,s,".WAV",double_file);
   s = get_str("ALARMSOUND");
   generate_path(fn_path,s,".WAV",alarm_file);
   s = get_str("STARTSOUND");
   generate_path(fn_path,s,".WAV",start_file);

   qso_autosave = get_bool("QSOAUTOSAVE",0);

   do_blink = get_bool("BLINKING",0);

//   use_ems = get_bool("EMS",1);
//   use_xms = get_bool("XMS",1);
   use_umb = get_bool("UMB",1);

   checkloc = get_int("CHECKLOCATOR",0);

   rotor = get_int("ROTOR_INTERFACE",0);
   rotor_ende = get_int("ROTOR_ENDPOSITION",0);

   printport = get_int("PRINTER_PORT",1);
   printer_type = get_int("PRINTER_TYPE",0);

   if(rotor > 3) rotor = 0;


   s = get_str("TNC_PORT");
   strcpy(tnc_port,s);

   s = get_str("TNC_BAUDRATE");
   strcpy(tnc_baudrate,s);

   tnc_channels = get_int("TNC_CHANNELS",4);

   tnc_channel_buf = get_int("TNC_CHANNEL_BUFFER",100);

   s = get_str("TNC_MYCALL");
   strcpy(tnc_mycall,s);

   tnc_tx_buf = get_int("TNC_TX_BUFFER",50);

//   lang = get_int("LANGUAGE",0);

   show_qrv_info = get_bool("SHOW_QRV_INFO",1);

   free_config();
   return(1);
};

// Sets the time of the PC-clock
void set_time(void)
{
   void *s;
   uchar res, sel;
   uchar hour[3];
   uchar minute[3];
   struct time t;
   unsigned h, m;
   uchar ch;

   s = make_win(20,5,60,13,menucol);

   dprint(34,6,menucol,"Adjust clock");
   dprint(35,8,menucol,"Time (UTC):");
   dfill(37,9,39,9,' ',menuinvcol);
   dprint(40,9,menucol,":");
   dfill(41,9,43,9,' ',menuinvcol);

   gettime(&t);
   sprintf(hour,"%02d",t.ti_hour);
   sprintf(minute,"%02d",t.ti_min);
   dprint(37,9,menuinvcol,hour);
   dprint(41,9,menuinvcol,minute);

   h = t.ti_hour;
   m = t.ti_min;

   paint_but(25,11,"OK",passivebuttoncol,menucol);
   paint_but(41,11,"  Abort  ",passivebuttoncol,menucol);

   sel = 1;

   do
   {
      switch(sel)
      {
         case 1:
            res = input_string(37,9,2,0,DO_TAB|DIGITS_ONLY,menuinvcol,hour);
            h = atoi(hour);
            if(h >= 24)
            {
                dfill(37,9,39,9,' ',menuinvcol);
                sprintf(hour,"%02d",t.ti_hour);
                dprint(37,9,menuinvcol,hour);
            };
            break;
         case 2:
            res = input_string(41,9,2,0,DO_TAB|DIGITS_ONLY,menuinvcol,minute);
            m = atoi(minute);
            if(m >= 60)
            {
               dfill(41,9,43,9,' ',menuinvcol);
               sprintf(minute,"%02d",t.ti_min);
               dprint(41,9,menuinvcol,minute);
            };
            break;
         case 3:
            my_gotoxy(80,lastline+1);
            paint_but(25,11,"OK",activebuttoncol,menucol);
            ch = getch();
            if(ch == 13) res = 90;
            if(ch == 27) res = 0;
            if(ch == 9)
            {
               res = TAB;
               paint_but(25,11,"OK",passivebuttoncol,menucol);
            };
            if(!ch)
            {
               ch = getch();
               if(ch == 15)
               {
                  res = BACKTAB;
                  paint_but(25,11,"OK",passivebuttoncol,menucol);
               };
            };
            break;
         case 4:
            my_gotoxy(80,lastline+1);
            paint_but(41,11,"  Abort  ",activebuttoncol,menucol);
            ch = getch();
            if(ch == 13) res = 90;
            if(ch == 27) res = 0;
            if(ch == 9)
            {
               res = TAB;
               paint_but(41,11,"  Abort  ",passivebuttoncol,menucol);
            };
            if(!ch)
            {
               ch = getch();
               if(ch == 15)
               {
                  res = BACKTAB;
                  paint_but(41,11,"  Abort  ",passivebuttoncol,menucol);
               };
            };
            break;
      };

      if(res == 1) res = TAB;
      if(res == TAB)
      {
         sel++;
         if(sel > 4) sel = 1;
      }
      if(res == BACKTAB)
      {
         sel--;
         if(sel < 1) sel = 4;
      }
   } while((res!=0)&&(res!=90));

   my_gotoxy(80,lastline+1);
   drestore(s);
   sec_free(s);

   if(res)
   {
      t.ti_hour = h;
      t.ti_min = m;
      t.ti_sec = 0;
      t.ti_hund = 0;
      settime(&t);
      updatetime();
   };
};

// Opens the pop-up-menu
void do_menu()
{
   void *save;
   void *save2;

   uchar choice = 7;
   uchar ch;
   uchar hlp[20];

   unsigned kilometers;
   int result;
   struct qso *q;
   struct definition *band = NULL;

   uchar *mode[4] = {"SSB"," CW","AUR"};
   uchar *sound[4] = {"AUS"," AN","WAV"};
   uchar *eng_sound[4] = {"OFF"," ON","WAV"};

   my_gotoxy(80,lastline+1);

   save = make_win(10,6,36,18,menucol);

   dprint(12,7,menucol,"QSO-statistics");
   dprint(12,8,menucol,"QSO-graphics...");
   dprint(12,9,menucol,"Squares...");
   dprint(12,10,menucol,"Country-statistics");
   dprint(12,11,menucol,"Distances-statistics");
   dprint(12,12,menucol,"QSO-maps...");
   dprint(12,13,menucol,"Mode:");
   dprint(12,14,menucol,"Sound:");
   dprint(12,15,menucol,"Change band...");
   dprint(12,16,menucol,"Adjust clock...");
   dprint(12,17,menucol,"Quit programme");

   dprint(32,13,menucol,mode[qso_mode]);
   dprint(32,14,menucol,eng_sound[do_sound]);
   dcolor(11,choice,35,choice,menuinvcol);

   do
   {
      do
      {
         ch = getch();
         if(!ch)
         {
            ch = getch();
            switch(ch)
            {
               case 80:
                  dcolor(11,choice,35,choice,menucol);
                  choice++;
                  if(choice > 17) choice = 7;
                  dcolor(11,choice,35,choice,menuinvcol);
                  break;
               case 72:
                  dcolor(11,choice,35,choice,menucol);
                  choice--;
                  if(choice < 7) choice = 17;
                  dcolor(11,choice,35,choice,menuinvcol);
                  break;
            }
         }
         if(ch == 27) choice = 0;
      } while(ch != 13 && ch != 27);

      switch(choice)
      {
         case 0:
            break;
         case 7:
            show_qso_stat();
            break;
         case 8:
            do_time_stat(do_bar_stat);
            break;
         case 9:
            save2 = make_win(38,9,55,13,menucol);
            dprint(40,10,menucol,"Map (Text)");
            dprint(40,11,menucol,"Map (graphics)");
            dprint(40,12,menucol,"Best squares");

            choice = 10;
            do
            {
               dcolor(39,choice,54,choice,menuinvcol);

               ch = getch();
               if(!ch)
               {
                  ch = getch();
                  switch(ch)
                  {
                     case 80:
                        dcolor(39,choice,54,choice,menucol);
                        choice++;
                        if(choice>12) choice = 10;
                        break;
                     case 72:
                        dcolor(39,choice,54,choice,menucol);
                        choice--;
                        if(choice<10) choice = 12;
                        break;
                  };
               }
               else if(ch == 27) choice = 0;
            } while(ch != 13 && choice);

            drestore(save2);
            sec_free(save2);
            if(choice)
            {
               switch(choice)
               {
                  case 10:
                     do_square_map();
                     break;
                  case 11:
                     show_square_graph();
                     break;
                  case 12:
                     do_top_squares();
                     break;
               };
            };
            choice = 9;
            break;
         case 10:
            do_country_stat();
            break;
         case 11:
            do_distances();
            break;
         case 12:
            save2 = make_win(38,12,55,15,menucol);
            dprint(40,13,menucol,"All QSOs");
            dprint(40,14,menucol,"Only DX...");

            choice = 13;
            do
            {
               dcolor(39,choice,54,choice,menuinvcol);

               ch = getch();
               if(!ch)
               {
                  ch = getch();
                  switch(ch)
                  {
                     case 80:
                        dcolor(39,choice,54,choice,menucol);
                        choice++;
                        if(choice>14) choice = 13;
                        break;
                     case 72:
                        dcolor(39,choice,54,choice,menucol);
                        choice--;
                        if(choice<13) choice = 14;
                        break;
                  };
               }
               else if(ch == 27) choice = 0;
            } while(ch != 13 && choice);

            drestore(save2);
            sec_free(save2);
            if(choice)
            {
               switch(choice)
               {
                  case 13:
                     do_all_map();
                     break;
                  case 14:
                     do_dx_map();
                     break;
               };
            };
            choice = 12;
            break;
         case 13:
            switch(qso_mode)
            {
               case MODE_SSB:
                  qso_mode = MODE_CW;
                  dprint(32,13,menuinvcol,mode[qso_mode]);
                  dprint(66,0,titlecol,mode[qso_mode]);
                  strcpy(hlp,"599");
                  break;
               case MODE_CW:
                  qso_mode = MODE_AUR;
                  dprint(32,13,menuinvcol,mode[qso_mode]);
                  dprint(66,0,titlecol,mode[qso_mode]);
                  strcpy(hlp,"59A");
                  break;
               case MODE_AUR:
                  qso_mode = MODE_SSB;
                  dprint(32,13,menuinvcol,mode[qso_mode]);
                  dprint(66,0,titlecol,mode[qso_mode]);
                  strcpy(hlp," 59");
                  break;
            };
            dprint(28,2,invcol,hlp);
            strcpy(actual_qso.rst_TX,hlp);
            break;
         case 14:
            do_sound++;
            if(do_sound>2) do_sound = 0;
            dprint(32,14,menuinvcol,eng_sound[do_sound]);
            break;
         case 15:
            if(valid<2) break;
            if(valid_qso(actual_qso))
            {
               ok_box("Warning","The actual QSO has not been saved!");
               break;
            };
            band = select_band();
            ch = 27;
            break;
         case 16:
            set_time();
            ch = 27;
            break;
         case 17:
            shutdown++;
            ch = 27;
            break;
      }
      my_gotoxy(80,lastline+1);
   } while(ch != 27);

   drestore(save);
   sec_free(save);
   last_key = *sys_timer;

   if(band && (band!=actual_def))
   {
      disable_band(actual_def);
      actual_def = band;
      enable_band(actual_def,1);
   };
};

// Sucht das ODX in der QSO-Liste
void find_ODX()
{
   struct qso *q;

   h.ODX_call[0] = 0;
   h.ODX = 0;
   q = firstqso;
   while(q)
   {
      if(q->points > h.ODX)
      {
         h.ODX = q->points;
         strcpy(h.ODX_call,q->call);
      }
      q = q->next;
   }
   dcolor(0,6,lastrow,6,titlecol);
   dprintf(1,6,titlecol,"%6lu points\263",h.points);
   dprintf(16,6,titlecol,"%4u km/QSO\263",h.average);
   dprintf(29,6,titlecol,"%4u km ODX (%s)",h.ODX,h.ODX_call);
   dprint(59,6,titlecol,"\263");
   dprintf(61,6,titlecol,"%-16s",pattern);
};

// Berechnet die Amzahl der Grofelder usw.
void calc_squares()
{
   struct qso *q;
   struct squareinfo *square;

   kill_all_squares();
   h.squares = 0;

   q = firstqso;
   while(q)
   {
      if(q->points)
      {
         square = find_square(q->locator);
         if(!square)
         {
            square = add_square(q->locator);
            h.squares++;
         }
         square->worked++;
         square->points += q->points;
      }
      q = q->next;
   }
   dprintf(48,0,titlecol,"C:%2u/SQ:%2u",h.countries,h.squares);
};

// Berechnet die Anzahl der Lnder...
void calc_countries()
{
   struct qso *q;
   struct countryinfo *prefix;

   h.countries = 0;
   h.unknown_pref = 0;

   prefix = firstcountry;
   while(prefix)
   {
      prefix->worked = 0;
      prefix->points = 0;
      prefix = prefix->next;
   }

   q = firstqso;
   while(q)
   {
      if(q->points)
      {
         prefix = find_prefix(q->barecall);
         if(!prefix) h.unknown_pref++;
         else
         {
            if(!prefix->worked) h.countries++;
            prefix->worked++;
            prefix->points += q->points;
         }
      }
      q = q->next;
   }
   dprintf(48,0,titlecol,"C:%2u/SQ:%2u",h.countries,h.squares);
};

// Berechnet die Anzahl der Punkte...
void calc_points()
{
   struct qso *q;

   h.points = 0;
   q = firstqso;
   while(q)
   {
      if(q->points) h.points+=q->points;
      q = q->next;
   }

   h.average = 0;
   if(h.qso_cnt-h.invalid) h.average = h.points / (h.qso_cnt - h.invalid);
   dcolor(0,6,lastrow,6,titlecol);
   dprintf(1,6,titlecol,"%6lu points\263",h.points);
   dprintf(16,6,titlecol,"%4u km/QSO\263",h.average);
   dprintf(29,6,titlecol,"%4u km ODX (%s)",h.ODX,h.ODX_call);
   dprint(59,6,titlecol,"\263");
   dprintf(61,6,titlecol,"%-16s",pattern);
};

// QSO editieren
void change_qso(struct qso *q)
{
   void *save;
   uchar time[6];
   uchar call[14];
   uchar rst_tx[4];
   uchar rst_rx[8];
   uchar loc[7];
   uchar select;
   uchar result;
   uchar th, tm;

   uchar n_pref[10];
   uchar n_call[10];
   uchar n_add[5];
   pchar cp;
   uchar s[15];
   uchar ch;
   unsigned lnr;

   double distance;
   double direction;
   double east;
   double north;

   struct qso *new_qso;

   FILE *cntfile;


   save = make_win(10,5,70,14,menucol);

   dprint(34,6,menucol,"  Edit QSO  ");

   dprint(12,8,menucol,"Time:");
   sprintf(time,"%02u:%02u",q->hour,q->min);
   dprintf(18,8,menuinvcol,"%-6s",time);

   dprint(26,8,menucol,"Call:");
   strcpy(call,q->call);
   dprintf(32,8,menuinvcol,"%-14s",call);

   dprint(12,10,menucol,"RST snd:");
   strcpy(rst_tx,q->rst_TX);
   cp = rst_tx;
   while(*cp && *cp == ' ') cp++;
   strcpy(rst_tx,cp);
   dprintf(21,10,menuinvcol,"%-4s",rst_tx);

   if(q->nr < 1000) dprintf(25,10,menucol,"%03u",q->nr);
   else dprintf(25,10,menucol,"%04u",q->nr);

   dprint(31,10,menucol,"RST rec:");
   strcpy(rst_rx,q->rst_RX);
   cp = rst_rx;
   while(*cp && *cp == ' ') cp++;
   strcpy(rst_rx,cp);
   dprintf(40,10,menuinvcol,"%-8s",rst_rx);

   dprint(50,10,menucol,"Locator:");
   strcpy(loc,q->locator);
   dprintf(59,10,menuinvcol,"%-7s",loc);

   paint_but(25,12,"OK",passivebuttoncol,menucol);
   paint_but(41,12,"  Abort  ",passivebuttoncol,menucol);

   select = 1;

   do
   {
      switch(select)
      {
         case 1:
            result = input_string(18,8,5,0,DO_TAB,menuinvcol,time);
            tm = 60;
            if(valid_time(time)) parse_time(time,&th,&tm);
            if(tm >= 60 || th >= 24)
            {
               dfill(18,8,23,8,' ',menuinvcol);
               time[0] = 0;
            }
            else
            {
               sprintf(time,"%02u:%02u",th,tm);
               dprintf(18,8,menuinvcol,"%-6s",time);
            }
            break;
         case 2:
            result = input_string(32,8,13,13,DO_TAB|CALL_CONVERT|UPCASE,menuinvcol,call);
            splitcall(call,n_pref,n_call,n_add);
            if(!n_call[0])
            {
               dfill(32,8,45,8,' ',menuinvcol);
               call[0] = 0;
            }
            else
            {
               call[0] = 0;
               if(*n_pref) sprintf(call,"%s/",n_pref);
               strcat(call,n_call);
               if(*n_add)
               {
                  strcat(call,"/");
                  strcat(call,n_add);
               }
               dprintf(32,8,menuinvcol,"%-14s",call);
            }
            break;
         case 3:
            result = input_string(21,10,3,0,DO_TAB|DIGITS_ONLY,menuinvcol,rst_tx);
            if(!valid_rst(rst_tx))
            {
               dfill(21,10,24,10,' ',menuinvcol);
               rst_tx[0] = 0;
            }
            break;
         case 4:
            result = input_string(40,10,7,0,DO_TAB,menuinvcol,rst_rx);
/*          if(!valid_rst(rst_rx) || strlen(rst_rx) < 3)
            {
               dfill(40,10,47,10,' ',menuinvcol);
               rst_rx[0] = 0;
            }
            else
            {
               strcpy(s,rst_rx);
               th = (qso_mode==MODE_SSB?2:3);
               memmove((pchar)s,(pchar)rst_rx,th);
               s[th] = 0;
               cp = (pchar)rst_rx+th;
               lnr = atoi(cp);

               if(lnr < 1000) sprintf(rst_rx,"%s%03u",s,lnr);
               else sprintf(rst_rx,"%s%04u",s,lnr);
            } */
            dprintf(40,10,menuinvcol,"%-8s",rst_rx);
//          }
            break;
         case 5:
            result = input_string(59,10,6,0,DO_TAB|UPCASE,menuinvcol,loc);
            if(!valid_locator(loc))
            {
               loc[0] = 0;
               dfill(59,10,65,10,' ',menuinvcol);
            }
            break;
         case 6:
            my_gotoxy(80,lastline+1);
            paint_but(25,12,"OK",activebuttoncol,menucol);
            ch = getch();
            if(ch == 13) result = 90;
            if(ch == 27) result = 0;
            if(ch == 9)
            {
               result = TAB;
               paint_but(25,12,"OK",passivebuttoncol,menucol);
            };
            if(!ch)
            {
               ch = getch();
               if(ch == 15)
               {
                  result = BACKTAB;
                  paint_but(25,12,"OK",passivebuttoncol,menucol);
               };
            };
            break;
         case 7:
            my_gotoxy(80,lastline+1);
            paint_but(41,12,"  Abort  ",activebuttoncol,menucol);
            ch = getch();
            if(ch == 13) result = 90;
            if(ch == 27) result = 0;
            if(ch == 9)
            {
               result = TAB;
               paint_but(41,12,"  Abort  ",passivebuttoncol,menucol);
            };
            if(!ch)
            {
               ch = getch();
               if(ch == 15)
               {
                  result = BACKTAB;
                  paint_but(41,12,"  Abort  ",passivebuttoncol,menucol);
               };
            };
            break;
      };

      if(result == 1) result = TAB;
      if(result == TAB)
      {
         select++;
         if(select > 7) select = 1;
      }
      if(result == BACKTAB)
      {
        select--;
        if(select < 1) select = 7;
      }
   } while((result!=0)&&(result!=90));

   my_gotoxy(80,lastline+1);
   drestore(save);
   sec_free(save);

   if(result)
   {
      if(time[0]&&call[0]&&rst_tx[0]&&rst_rx[0]&&loc[0])
      {
         new_qso = NULL;
         parse_time(time,&th,&tm);
         splitcall(call,n_pref,n_call,n_add);
         result = 1;

         if(strcmp(call,q->call))   // Das Rufzeichen wurde irgendwie gendert!
         {
            if(strcmp(n_call,q->barecall))
            {
               new_qso = find_qso(n_call);
               result = 1;
               if(new_qso) result = ok_abort_box("Warning","Callsign has already been logged and will count 0 points!");
          
               if(!q->points && !new_qso) result = ok_abort_box("Warning","QSO now valid, will be counted!");
            };
         };

         if(result)
         {
            if(th != q->hour) q->hour = th;
            if(tm != q->min) q->min = tm;

            if(strcmp(q->call,call))
            {
               if(strcmp(q->barecall,n_call))
               {
                  if(!q->points && !new_qso)
                  {
                     loc2coord(loc,&east,&north);
                     dist_and_dir(own_east,own_north,east,north,&distance,&direction);
                     q->points = (unsigned)(distance+0.5);
                     q->direction = (unsigned)direction;
                  };

                  if(new_qso && !strcmp(new_qso->barecall,n_call))
                  {
                     q->points = 0;
                     q->direction = 361;
                  }
               };

               strcpy(q->barecall,n_call);
               strcpy(q->call,call);
               calc_squares();
               calc_points();
               find_ODX();
               display_last_hour();
               calc_countries();
            }

            if(strcmp(q->locator,loc))
            {
               strcpy(q->locator,loc);
               loc2coord(loc,&east,&north);
               dist_and_dir(own_east,own_north,east,north,&distance,&direction);
               q->points = (unsigned)(distance+0.5);
               q->direction = (unsigned)direction;

               calc_squares();
               calc_points();
               find_ODX();
               display_last_hour();
            }

            sprintf(q->rst_RX,"%7s",rst_rx);
            sprintf(q->rst_TX,"%3s",rst_tx);

            cntfile = fopen(cntname,"r+b");
            fwrite((void *)&h,1,HEADER_SIZE,cntfile);
            fclose(cntfile);

            cntfile = fopen(cntname,"r+b");
            fseek(cntfile,((q->nr-1)*FILEBYTE_PER_QSO)+HEADER_SIZE,SEEK_SET);
            write_a_qso(*q,cntfile);
            fclose(cntfile);
         }
      }
      else
      {
         ok_box("Error","Invalid input");
      }
   };

// repaint();
}


// Tastenbelegung fr die QSO-Liste
void qso_edit_help()
{
   void *save;
   char ch;

   save = dsave(0,0,lastrow,lastline);

   dfill(0,0,lastrow,lastline,' ',menucol);
   dprint(24,1,menucol," Key assignments in the QSO-list ");
   dfill(25,2,55,2,220,menucol);

   dprint(2,5,(menucol&0xF0)+YELLOW,"F4");
   dprint(5,5,menucol,"- Display current QSO in map");

   dprint(2,7,(menucol&0xF0)+YELLOW,"RETURN");
   dprint(9,7,menucol,"- Edit selected QSO");

   dprint(2,9,(menucol&0xF0)+YELLOW,"DEL");
   dprint(6,9,menucol,"- Delete/invalidate selected QSO");

   dprint(2,11,(menucol&0xF0)+YELLOW,"ESC");
   dprint(2,12,(menucol&0xF0)+YELLOW,"F9");
   dprint(6,12,menucol,"- Quit QSO-list, return to logging");

   dprint(2,14,(menucol&0xF0)+YELLOW,"ALT-X");
   dprint(8,14,menucol,"- Quit programme");

   dprint(2,17,(menucol&0xF0)+YELLOW,"Cursor-Up/Cursor-Down");
   dprint(2,18,(menucol&0xF0)+YELLOW,"Page-Up/Page-Down");
   dprint(2,19,(menucol&0xF0)+YELLOW,"Home/End");
   dprint(24,18,menucol,"- Browse through the QSO-list");

   paint_but(36,22,"OK",activebuttoncol,menucol);

   do
   {
      ch = getch();
   } while((ch!=13)&&(ch!=27));

   drestore(save);
   sec_free(save); 
};  


// QSO-Auswahlliste
void do_qso_edit()
{
   struct qso *last_vis_qso;
   struct qso *first_vis_qso;
   struct qso *selected_qso;
   struct qso *hlp;
   uchar line;
   uchar i;
   uchar ch;
   uchar call[14];
   unsigned found;
   double east, north;
   double distance, direction;

   uchar str[80];

   FILE *cntfile;


   dfill(0,lastline,lastrow,lastline,' ',titlecol);
   dprint(1,lastline,titlecol,"F1 - Help");

   strcpy(pattern,"*");
   print_qso(pattern,1);

   hlp = lastqso;
   for(i=0;i<15;i++)
      if(hlp) hlp = hlp->prev;


   my_gotoxy(80,lastline+1);

   last_vis_qso = lastqso;
   selected_qso = lastqso;
   first_vis_qso = lastqso;
   line = lastline-1;
   i = 1;

   while(first_vis_qso->prev && i < 15)
   {
      first_vis_qso = first_vis_qso->prev;
      i++;
   }
   dcolor(0,line,46,line,invcol);

   do
   {
      while(!kbhit()) updatetime();
      ch = getch();
      last_key = *sys_timer;
      if(!ch)
      {
         ch = getch();
         switch(ch)
         {
            case 104:    // ALT-F1
               do_mem_stat();
               break;
            case 45:     // Alt-X
               if(yes_no_box("Quit programme","Are you sure?")) shutdown++;
               ch = 27;
               break;
            case 59:    // F1
               qso_edit_help();
               break;
            case 62:                   // F4
               if(!graphics) break;
               if(graph_mode())
               {
                  display_grid();
                  display_map(h.owncall,h.ownloc);
                  display_borders();
                  strcpy(call,selected_qso->call);
                  make_norm_call(call,call);
                  display_path(h.ownloc,selected_qso->locator,call);
                  display_loc(h.ownloc,h.owncall);
                  getch();
                  text_mode();
                  my_gotoxy(80,lastline+1);
               };
               break;
            case 67:                // F9
               ch = 27;
               break;
 
            case 83:      // DEL
               if(!selected_qso->points && selected_qso->nr!=lastqso->nr)
               {
                  if(!yes_no_box("Question","Treat this QSO as valid again?")) break;
                  strcpy(call,selected_qso->barecall);
                  found = 0;
                  for(hlp = firstqso; hlp ; hlp = hlp->next)
                  {
                     if(!strcmp(hlp->barecall,call) && hlp->points) found++;
                  };

                  if(found)
                  {
                     ok_box("Warning","This QSO is a dupe!");
                     break;
                  };
 
                  loc2coord(selected_qso->locator,&east,&north);
                  dist_and_dir(own_east,own_north,east,north,&distance,&direction);
                  selected_qso->points = (unsigned)(distance+0.5);
                  selected_qso->direction = (unsigned)direction;

                  h.invalid--;

                  find_ODX();
                  calc_squares();
                  calc_points();
                  calc_countries();
                  display_last_hour();

                  cntfile = fopen(cntname,"r+b");
                  fwrite((void *)&h,HEADER_SIZE,1,cntfile);
                  fclose(cntfile);

                  cntfile = fopen(cntname,"r+b");
                  fseek(cntfile,((selected_qso->nr-1)*FILEBYTE_PER_QSO)+HEADER_SIZE,SEEK_SET);
                  write_a_qso(*selected_qso,cntfile);
                  fclose(cntfile);

                  print_qso_line(selected_qso,line);
                  dcolor(0,line,46,line,invcol);

                  ok_box("Confirmation","This QSO is valid again!");
                  break;
               };
               if(yes_no_box("Confirmation","Treat QSO as invalid again?"))
               {
                  if(selected_qso->nr < h.qso_cnt)
                  {
                     selected_qso->points = 0;
                     selected_qso->direction = 361;

                     h.invalid++;

                     find_ODX();
                     calc_squares();
                     calc_points();
                     calc_countries();

                     cntfile = fopen(cntname,"r+b");
                     fwrite((void *)&h,HEADER_SIZE,1,cntfile);
                     fclose(cntfile);

                     cntfile = fopen(cntname,"r+b");
                     fseek(cntfile,((selected_qso->nr-1)*FILEBYTE_PER_QSO)+HEADER_SIZE,SEEK_SET);
                     write_a_qso(*selected_qso,cntfile);
                     fclose(cntfile);

                     print_qso_line(selected_qso,line);
                     dcolor(0,line,46,line,invcol);
                  }
                  else
                  {
                     h.qso_cnt--;
                     if(!h.qso_cnt) ch = 27;

                     hlp = lastqso;
                     if(!hlp->points) h.invalid--;
                     lastqso = hlp->prev;
                     if(!lastqso) firstqso = NULLqso;
                     else lastqso->next = NULLqso;
                     sec_free(hlp);
                     last_vis_qso = lastqso;
                     selected_qso = lastqso;
                     if(first_vis_qso->prev) first_vis_qso = first_vis_qso->prev;

                     find_ODX();
                     calc_squares();
                     calc_points();
                     calc_countries();

                     dprintf(38,0,numbercol,"%4d",h.qso_cnt+1);
                     if(h.qso_cnt<999) dprintf(32,2,textcol,"%03d",h.qso_cnt+1);
                     else dprintf(31,2,textcol,"%4d",h.qso_cnt+1);

                     write_contest_file(cntname,&h,actual_def->band);
   
                     hlp = last_vis_qso;
                     i = 1;
                     while(i < 15)
                     {
                        print_empty_line(lastline-i);
                        if(hlp)
                        {
                           print_qso_line(hlp,lastline-i);
                           hlp = hlp->prev;
                        }
                        i++;
                     }
                     dcolor(0,line,46,line,invcol);
                  }
               }

               break;

            case 81:     // Page-down
               if(selected_qso->nr == lastqso->nr && do_sound)
               {
                  sound(200);
                  delay(100);
                  nosound();
                  break;
               };
               i = lastline-10;
               while(i && selected_qso->next)
               {
                  selected_qso = selected_qso->next;
                  if(last_vis_qso->next)
                  {
                     last_vis_qso = last_vis_qso->next;
                     first_vis_qso = first_vis_qso->next;
                  };
                  i--;
               };
               if(!last_vis_qso->next && (i || !selected_qso->next)) line = lastline-1;

               if(selected_qso->nr == first_vis_qso->nr && selected_qso->next)
               {
                  line++;
                  selected_qso = selected_qso->next;
               };

               hlp = last_vis_qso;
               i = 1;
               while(i < lastline-8)
               {
                  print_empty_line(lastline-i);
                  if(hlp)
                  {
                     print_qso_line(hlp,lastline-i);
                     hlp = hlp->prev;
                  }
                  i++;
               };
               dcolor(0,line,46,line,invcol);
               break;

            case 80:     // Cursor-down
               if(selected_qso->nr == lastqso->nr && do_sound)
               {
                  sound(200);
                  delay(100);
                  nosound();
                  break;
               };
               if(selected_qso->next == last_vis_qso)
               {
                  if(last_vis_qso != lastqso)
                  {
                     dcolor(0,line,46,line,textcol);
                     dmove(0,10,79,lastline-1,0,9);

                     last_vis_qso = last_vis_qso->next;

                     first_vis_qso = first_vis_qso->next;

                     selected_qso = selected_qso->next;

                     print_qso_line(last_vis_qso,lastline-1);
                     dcolor(0,line,46,line,invcol);
                     break;
                  }
               }
               dcolor(0,line,46,line,textcol);
               line++;
               dcolor(0,line,46,line,invcol);
               selected_qso = selected_qso->next;
               break;

            case 73:     // Page-Up
               if(selected_qso->nr == firstqso->nr && do_sound)
               {
                  sound(200);
                  delay(100);
                  nosound();
                  break;
               }

               i = lastline-10;
               while(i && selected_qso->prev)
               {
                  selected_qso = selected_qso->prev;
                  if(first_vis_qso->prev)
                  {
                     first_vis_qso = first_vis_qso->prev;
                     last_vis_qso = last_vis_qso->prev;
                  };
                  i--;
               };

               if((!first_vis_qso->prev) && i)
               {
                  line = lastline;
                  hlp = last_vis_qso;
                  while(hlp)
                  {
                     line--;
                     hlp = hlp->prev;
                  };
               };

               if(line==lastline-1)
               {
                  line--;
                  last_vis_qso = last_vis_qso->next;
                  first_vis_qso = first_vis_qso->next;
               };

               hlp = last_vis_qso;
               i = 1;
               while(i < lastline-8)
               {
                  print_empty_line(lastline-i);
                  if(hlp)
                  {
                     print_qso_line(hlp,lastline-i);
                     hlp = hlp->prev;
                  }
                  i++;
               };

               hlp = first_vis_qso;
               line = 9;
               while(hlp->nr!=selected_qso->nr)
               {
                  line++;
                  hlp = hlp->next;
               };

               dcolor(0,line,46,line,invcol);
               break;

            case 72:     // Cursor-up
               if(selected_qso->nr == firstqso->nr && do_sound)
               {
                  sound(200);
                  delay(100);
                  nosound();
                  break;
               }
               if(selected_qso->prev == first_vis_qso)
               {
                  if(first_vis_qso->nr != firstqso->nr)
                  {
                     dcolor(0,line,46,line,textcol);
                     dmove(0,9,lastrow,lastline-2,0,10);

                     last_vis_qso = last_vis_qso->prev;

                     first_vis_qso = first_vis_qso->prev;

                     selected_qso = selected_qso->prev;

                     print_qso_line(first_vis_qso,9);
                     dcolor(0,line,46,line,invcol);
                     break;
                  }
               }
               dcolor(0,line,46,line,textcol);
               line--;
               dcolor(0,line,46,line,invcol);
               selected_qso = selected_qso->prev;
               break;

            case 79:       // End
               selected_qso = lastqso;
               last_vis_qso = lastqso;
               line = lastline-1;

               i = lastline-10;
               first_vis_qso = lastqso;
               while(i&&first_vis_qso->prev)
               {
                  i--;
                  first_vis_qso = first_vis_qso->prev;
               };

               hlp = last_vis_qso;
               i = 1;
               while(i < lastline-8)
               {
                  print_empty_line(lastline-i);
                  if(hlp)
                  {
                     print_qso_line(hlp,lastline-i);
                     hlp = hlp->prev;
                  }
                  i++;
               };
               dcolor(0,line,46,line,invcol);
               break;

            case 71:          // Home
               selected_qso = firstqso;
               first_vis_qso = firstqso;

               i = 1;
               last_vis_qso = firstqso;

               while((i<lastline-9) && last_vis_qso->next)
               {
                  i++;
                  last_vis_qso = last_vis_qso->next;
               };

               line = lastline-i;

               hlp = last_vis_qso;
               i = 1;
               while(i < lastline-8)
               {
                  print_empty_line(lastline-i);
                  if(hlp)
                  {
                     print_qso_line(hlp,lastline-i);
                     hlp = hlp->prev;
                  }
                  i++;
               };
               dcolor(0,line,46,line,invcol);
               break;
         }
      }
      else
      if(ch==13)
      {
         change_qso(selected_qso);
         print_qso_line(selected_qso,line);
         dcolor(0,line,46,line,invcol);
         my_gotoxy(80,lastline+1);
      }
   } while(ch != 27);

   dcolor(0,line,46,line,textcol);
/*
   if(comm_write<save_pr_lines) i = comm_lines-save_pr_lines+comm_write;
   else i = comm_write-save_pr_lines;

   while(pr_lines<save_pr_lines)
   {
      dmove(0,8+pr_lines,lastrow,9+pr_lines,0,9+pr_lines);
      dfill(0,8+pr_lines,lastrow,8+pr_lines,' ',textcol);
      if(comm_buf[i]) dprint(0,8+pr_lines,textcol,comm_buf[i]);
      i++;
      if(i==comm_lines) i=0;
      pr_lines++;
      delay(50);
   };
*/
// repaint(); 
};

BOOL valid_qso(struct qso q)
{
   return((!call_incomplete) && q.call[0] && q.rst_RX[0] && q.locator[0]);
};
  

// Tastenbelegung fr das Logging
void logging_help()
{
   void *save;
   char ch;

/*
   save = dsave(0,0,lastrow,lastline);

   my_gotoxy(80,lastline+1);

   dfill(0,0,lastrow,lastline,' ',menucol);
   dprint(22,1,menucol,lang?"Tastaturbelegung whrend des Loggens":"   Key assignments while logging   ");
   dfill(lang?22:25,2,lang?57:53,2,220,menucol);

   dprint(2,4,(menucol&0xF0)+YELLOW,"F10");
   if(lang) dprint(5,4,menucol,"- Pop-Up-Men mit weiteren Funktionen aufrufen");
   else dprint(5,4,menucol,"- Invoke popup-menu with further functions");

   dprint(2,6,(menucol&0xF0)+YELLOW,"F2");
   if(lang) dprint(5,6,menucol,"- QSO speichern, falls komplett");
   else dprint(5,6,menucol,"- Save QSO if complete");

   dprint(2,8,(menucol&0xF0)+YELLOW,"F3");
   if(lang) dprint(5,8,menucol,"- Aktuelles QSO lschen");
   else dprint(5,8,menucol,"- Discard actual QSO");

   dprint(2,10,(menucol&0xF0)+YELLOW,"F4");
   if(lang) dprint(5,10,menucol,"- Anzeige des QSOs in der Europa-Karte");
   else dprint(5,10,menucol,"- Display current QSO in map");

   dprint(2,12,(menucol&0xF0)+YELLOW,"F5");
   if(lang) dprint(5,12,menucol,"- Rotor in Richtung des angegebenen Locators drehen (IF-100)");
   else dprint(5,12,menucol,"- Turn antenna towards given locator (IF-100)");

   dprint(2,14,(menucol&0xF0)+YELLOW,"F6");
   if(lang) dprint(5,14,menucol,"- Log-Band auswhlen (auch: Ctrl-Up/Ctrl-Down)");
   else dprint(5,14,menucol,"- Select band (also: Ctrl-Up/Ctrl-Down)");

   dprint(2,16,(menucol&0xF0)+YELLOW,"F7");
   if(lang) dprint(5,16,menucol,"- Betriebsart ndern (SSB/CW/AURora)");
   else dprint(5,16,menucol,"- Change mode (SSB/CW/AURora)");

   dprint(2,18,(menucol&0xF0)+YELLOW,"F9");
   if(lang) dprint(5,18,menucol,"- In die QSO-Liste wechseln");
   else dprint(5,18,menucol,"- Change to QSO-list");

   dprint(2,20,(menucol&0xF0)+YELLOW,"ESC");
   if(lang) dprint(6,20,menucol,"- Eingabezeile lschen");
   else dprint(6,20,menucol,"- Cancel input line");

   dprint(52,20,(menucol&0xF0)+YELLOW,"ALT-X");
   if(lang) dprint(58,20,menucol,"- Programm beenden");
   else dprint(58,20,menucol,"- Quit programme");

   paint_but(36,22,"OK",activebuttoncol,menucol);

   do
   {
      ch = getch();
   } while((ch!=13)&&(ch!=27));

   drestore(save);
   lowfree(save); */
};  


#define HIST_BUF 50

void do_logging()
{
   uchar hlp[81];
   uchar i;
   struct qso *doubleqso;
   pchar cp;
   pchar nextcp;
   uchar s[80];
   uchar cpos;
   uchar dx, dy;
   uchar slen;
   uchar ch;
   struct definition *band;
   uchar done;
   double east;
   double north;
   double distance;
   double direction;

   signed char hist_pos, hist_ptr, hist_act;
   uchar hist[HIST_BUF][32];
   uchar hist_str[32];
   uchar gefunden;
   uchar str[80];

   memset(hist,0,sizeof(hist));
   hist_ptr = 0;

   scp = scroll_text;

   strcpy(op_call,"");
   strcpy(log_call,"");

   hlp[1] = 0;
   dx     = 1;
   dy     = 4;

   memset(&actual_qso,0,QSO_SIZE);
   call_incomplete = CALL_MISS;

   switch(qso_mode)
   {
      case MODE_SSB:
         strcpy(actual_qso.rst_TX," 59");
         break;
      case MODE_CW:
         strcpy(actual_qso.rst_TX,"599");
         break;
      case MODE_AUR:
         strcpy(actual_qso.rst_TX,"59A");
         break;
   };
   dprint(28,2,invcol,actual_qso.rst_TX);

//   comm_printf("Welcome to FiveNine v2.00ALPHA!");

   ok_box("\001\002  FiveNine v1.60","(C) 1994-96 by Stefan Pfeiffer, DL1ELY");

   sys_timer = (unsigned long *)MK_FP(0x40,0x6C);
   last_key = *sys_timer;

   shutdown = 0;

   do
   {
      hist_pos = 0;
      hist_act = -1;
      dfill(dx,dy,dx+59,dy,' ',invcol);
      slen = 0;
      s[0] = 0;
      cpos = 0;

      do
      {
         my_gotoxy(dx+cpos,dy);
         while(!kbhit()) updatetime();
         ch = getch();

         if(scroll)
         {
            repaint();
            last_key = *sys_timer;
            scp = scroll_text;
            scroll = 0;
         }

         switch(ch)
         {
            case 0:           // Sondertaste
               ch = getch();
               switch(ch)
               {
                  case 72:      // Cursor-up
                     if(cpos < slen) break;
                     if(hist_act<0)
                     {
                        hist_pos = slen;
                        while(hist_pos && (s[hist_pos]!=' ') && (s[hist_pos]!=','))
                        hist_pos--;
 
                        if(hist_pos<slen)
                        {
                           if(hist_pos) hist_pos++;
                           memcpy(hist_str,s+hist_pos,slen-hist_pos);
                           hist_str[slen-hist_pos] = 0;
                        }
                        else hist_str[0] = 0;
 
                        hist_act = hist_ptr;
                        do
                        {
                           hist_act--;
                           if(hist_act<0) hist_act = HIST_BUF-1;
                           if(strlen(hist_str))
                              gefunden = (!strncmp(hist_str,hist[hist_act],strlen(hist_str))) && hist[hist_act][0];
                           else
                              gefunden = hist[hist_act][0];
                        } while(!gefunden && (hist_act!=hist_ptr));

                        if(hist_act == hist_ptr)
                        {
                           sound(200);
                           delay(100);
                           nosound();
                           break;
                        };
                     }
                     else
                     {
                        do
                        {
                           hist_act--;
                           if(hist_act<0) hist_act = HIST_BUF-1;
                           if(strlen(hist_str))
                              gefunden = (!strncmp(hist_str,hist[hist_act],strlen(hist_str))) && hist[hist_act][0];
                           else
                              gefunden = hist[hist_act][0];
                        } while(!gefunden && (hist_act!=hist_ptr));

                        if(hist_act== hist_ptr)
                        {
                           sound(200);
                           delay(100);
                           nosound();
                           break;
                        };
                     };

                     if(hist[hist_act][0])
                     {
                        s[hist_pos] = 0;
                        slen = hist_pos;
                        cpos = hist_pos;
                        memcpy(s+slen,hist[hist_act],strlen(hist[hist_act]));
                        slen+=strlen(hist[hist_act]);
                        s[slen] = 0;
                        cpos+=strlen(hist[hist_act]);
                        if(cpos>59)
                        {
                           cpos = 59;
                           s[74] = 0;
                        };
                        dfill(dx,dy,dx+59,dy,' ',invcol);
                        dprint(dx,dy,invcol,s);
                     }
                     else
                     {
                        sound(200);
                        delay(100);
                        nosound();
                     };
                     break;
                  case 80:      // Cursor-down
                     if(cpos < slen) break;
                     if(hist_act<0)
                     {
                        hist_pos = slen;
                        while(hist_pos && (s[hist_pos]!=' ') && (s[hist_pos]!=',')) hist_pos--;
 
                        if(hist_pos<slen)
                        {
                           if(hist_pos) hist_pos++;
                           memcpy(hist_str,s+hist_pos,slen-hist_pos);
                           hist_str[slen-hist_pos] = 0;
                        }
                        else hist_str[0] = 0;
 
                        hist_act = hist_ptr;
                        do
                        {
                           hist_act++;
                           if(hist_act>HIST_BUF-1) hist_act = 0;
                           if(strlen(hist_str))
                              gefunden = (!strncmp(hist_str,hist[hist_act],strlen(hist_str))) && hist[hist_act][0];
                           else
                              gefunden = hist[hist_act][0];
                        } while(!gefunden && (hist_act!=hist_ptr));

                        if(hist_act == hist_ptr)
                        {
                           sound(200);
                           delay(100);
                           nosound();
                           break;
                        };
                     }
                     else
                     {
                        do
                        {
                           hist_act++;
                           if(hist_act>HIST_BUF-1) hist_act = 0;
                           if(strlen(hist_str))
                              gefunden = (!strncmp(hist_str,hist[hist_act],strlen(hist_str))) && hist[hist_act][0];
                           else
                              gefunden = hist[hist_act][0];
                        } while(!gefunden && (hist_act!=hist_ptr));

                        if(hist_act== hist_ptr)
                        {
                           sound(200);
                           delay(100);
                           nosound();
                           break;
                        };
                     };

                     if(hist[hist_act][0])
                     {
                        s[hist_pos] = 0;
                        slen = hist_pos;
                        cpos = hist_pos;
                        memcpy(s+slen,hist[hist_act],strlen(hist[hist_act]));
                        slen+=strlen(hist[hist_act]);
                        s[slen] = 0;
                        cpos+=strlen(hist[hist_act]);
                        if(cpos>59)
                        {
                           cpos = 59;
                           s[74] = 0;
                        };
                        dfill(dx,dy,dx+59,dy,' ',invcol);
                        dprint(dx,dy,invcol,s);
                     }
                     else
                     {
                        sound(200);
                        delay(100);
                        nosound();
                     };
                     break;
                  case 145:     // Ctrl-Down
                     if(valid<2) break;
                     if(valid_qso(actual_qso))
                     {
                        ok_box("Warning","The actual QSO has not been saved!");
                        break;
                     };
                     disable_band(actual_def);
                     do
                     {
                        actual_def = actual_def->next;
                        if(!actual_def) actual_def = firstdef;
                     } while(!actual_def->found);
                     enable_band(actual_def,1);
                     repaint();
                     break;
                  case 141:     // Ctrl-Up
                     if(valid<2) break;
                     if(valid_qso(actual_qso))
                     {
                        ok_box("Warning","The actual QSO has not been saved!");
                        break;
                     };

                     disable_band(actual_def);
                     do 
                     {
                        actual_def = actual_def->prev;
                        if(!actual_def) actual_def = lastdef;
                     } while(!actual_def->found);
                     enable_band(actual_def,1);
                     repaint();
                     break;
                  case 104:     // ALT-F1
                     do_mem_stat();
                     break;
                  case 105:     // ALT-F2
                     disp_result_prediction();
                     break;
                  case 45:      // ALT-X
                     if(yes_no_box("Quit programme","Are you sure?")) shutdown++;
                     break;
                  case 77:      // Cursor right
                     if(cpos < slen) cpos++;
                     hist_act = -1;
                     break;
                  case 75:      // Cursor left
                     if(cpos) cpos--;
                     hist_act = -1;
                     break;
                  case 63:      // F5
                     if(rotor && actual_qso.locator[0])
                     {
                        if(strcmp(h.ownloc,actual_qso.locator))
                        {
                           loc2coord(actual_qso.locator,&east,&north);
                           dist_and_dir(own_east,own_north,east,north,&distance,&direction);
                           pio_rotor(rotor,(unsigned)direction,rotor_ende);
                        }
                     };
                     break;
                  case 64:      // F6
                     if(valid<2) break;
                     if(valid_qso(actual_qso))
                     {
                        ok_box("Warning","The actual QSO has not been saved!");
                        break;
                     };

                     band = select_band();
                     if(band && (band!=actual_def))
                     {
                        disable_band(actual_def);
                        actual_def = band;
                        enable_band(actual_def,1);
                     };
                     break;
                  case 65:      // F7
                     switch(qso_mode)
                     {
                        case MODE_SSB:
                           qso_mode = MODE_CW;
                           dprint(66,0,titlecol," CW");
                           strcpy(hlp,"599");
                           break;
                        case MODE_CW:
                           qso_mode = MODE_AUR;
                           dprint(66,0,titlecol,"AUR");
                           strcpy(hlp,"59A");
                           break;
                        case MODE_AUR:
                           qso_mode = MODE_SSB;
                           dprint(66,0,titlecol,"SSB");
                           strcpy(hlp," 59");
                           break;
                     };
                     dprint(28,2,invcol,hlp);
                     strcpy(actual_qso.rst_TX,hlp);
                     break;
                  case 67:      // F9
                     if(h.qso_cnt) do_qso_edit();
                     ch = 13;
                     break;
                  case 68:      // F10
                     do_menu();
                     break;
                  case 82:
                     do_insert ^= 1;
                     if((graphics == EGA)||(graphics == VGA))
                        if(do_insert) def_cursor(6,7);
                     else def_cursor(0,7);
                     break;
                  case 62:      // F4
                     if(!graphics) break;
                     if(actual_qso.locator[0])
                     {
                        if(graph_mode())
                        {
                           display_grid();
                           display_map(h.owncall,h.ownloc);
                           display_borders();
                           strcpy(hlp,actual_qso.call);
                           make_norm_call(hlp,hlp);
                           display_path(h.ownloc,actual_qso.locator,hlp);
                           display_loc(h.ownloc,h.owncall);
                           if(!getch()) getch();
                           text_mode();
                        };
                     };
                     break;
                  case 59:    // F1
                     logging_help();
                     break;
                  case 60:      // F2
                     if(valid_qso(actual_qso))
                     {
                        save_akt_qso();
                        kill_akt_qso();
                        dfill(dx,dy,dx+59,dy,' ',invcol);
                        slen = 0;
                        s[0] = 0;
                        cpos = 0;
                        hist_act = -1;
                        dfill(1,lastline,lastrow,lastline,' ',titlecol);
                        dprint(75,2,(textcol&0xF0)+RED,"---");
                        dprint(1,lastline,titlecol,"F1 - Help");
                        strcpy(pattern,"*");
                        print_qso(pattern,0);
                     }
                     break;
                  case 61:      // F3
                     if(!yes_no_box("Confirmation","Should the actual QSO-data be deleted?")) break;
                     kill_akt_qso();
                     dfill(dx,dy,dx+59,dy,' ',invcol);
                     slen = 0;
                     s[0] = 0;
                     cpos = 0;
                     hist_act = -1;
                     dfill(1,lastline,lastrow,lastline,' ',titlecol);
                     dprint(75,2,(textcol&0xF0)+RED,"---");
                     dprint(1,lastline,titlecol,"F1 - Help");
                     strcpy(pattern,"*");
                     print_qso(pattern,0);
                     break;
                  case 83:      /* Delete */
                     if(!slen)
                     {
                        kill_akt_qso();
                        dfill(dx,dy,dx+59,dy,' ',invcol);
                        slen = 0;
                        s[0] = 0;
                        cpos = 0;
                        hist_act = -1;
                        strcpy(pattern,"*");
                        print_qso(pattern,0);
                     }
                     else
                     {
                        if(cpos < slen)
                        {
                           memmove((char *)s+cpos,(char *)s+cpos+1,slen-cpos);
                           dfill(dx,dy,dx+59,dy,' ',invcol);
                           dprint(dx,dy,invcol,s);
                           slen--;
                        }
                        hist_act = -1;
                        break;
                     }
               }
               break;

            case 27:          /* ESCape */
               if(!slen) kill_akt_qso();
               if(hist_act>=0)
               {
                  s[hist_pos] = 0;
                  slen = hist_pos;
                  cpos = hist_pos;
                  memcpy(s+slen,hist_str,strlen(hist_str));
                  slen+=strlen(hist_str);
                  s[slen] = 0;
                  cpos+=strlen(hist_str);
                  if(cpos>59)
                  {
                     cpos = 59;
                     s[74] = 0;
                  };
                  dfill(dx,dy,dx+59,dy,' ',invcol);
                  dprint(dx,dy,invcol,s);
                  hist_act = -1;
               }
               else
               {
                  dfill(dx,dy,dx+59,dy,' ',invcol);
                  slen = 0;
                  s[0] = 0;
                  cpos = 0;
                  hist_act = -1;
                  strcpy(pattern,"*");
                  print_qso(pattern,0);
               };
               break;
            case 8:           /* Backspace */
               if(cpos)
               {
                  if(cpos < slen)
                  {
                     memmove((char *)s+cpos-1,(char *)s+cpos,slen-cpos+1);
                     dfill(dx,dy,dx+59,dy,' ',invcol);
                     dprint(dx,dy,invcol,s);
                  }
                  else dprint(dx+cpos-1,dy,invcol," ");
                  slen--;
                  cpos--;
                  s[slen] = 0;
               }
               hist_act = -1;
               break;
            case 13:         /* CR */
               if(!s[0])
               {
                  if(actual_qso.barecall[0])
                  {
                     doubleqso = find_qso(actual_qso.barecall);
                     if(valid_qso(actual_qso) && (!doubleqso || actual_qso.rst_RX[0])) save_akt_qso();
                     if(doubleqso || (valid_qso(actual_qso) && !doubleqso))
                     {
                        kill_akt_qso();
                        strcpy(pattern,"*");
                        print_qso(pattern,0);
                     };
            
                     if(call_incomplete == PREFIX_MISS)
                     {
                        cp = actual_qso.barecall;
                        while(*cp == '?') cp++;

                        doubleqso = firstqso;
                        while(doubleqso && (!strstr(doubleqso->call,cp))) doubleqso = doubleqso->next;

                        if(doubleqso)
                        {
                           kill_akt_qso();
                           strcpy(pattern,"*");
                           print_qso(pattern,0);
                        };
                     };
                  }
                  else
                  {
                     if(actual_qso.locator[0])
                     {
                        for(doubleqso = firstqso;doubleqso && strcmp(doubleqso->locator,actual_qso.locator);doubleqso = doubleqso->next) ;
                        if(doubleqso)
                        {
                           kill_akt_qso();
                           strcpy(pattern,"*");
                           print_qso(pattern,0);
                        };
                     };
                  };
               };
               break;

            case '#':     /* # -> /P  */
               hist_act = -1;
               if(cpos > 75)
               {
                  sound(200);
                  delay(100);
                  nosound();
                  break;
               }
               if((cpos < slen) && do_insert)
                  memmove((char *)s+cpos+2,(char *)s+cpos,slen-cpos-1);
               s[cpos] = '/';
               cpos++;
               s[cpos] = 'P';
               cpos++;
               slen+=2;
               s[slen] = 0;
               dprint(dx,dy,invcol,s);
               break;
            case '-':
            case '/':
            case 225:        /* ss -> / und '-' -> /  */
               hist_act = -1;
               if(cpos > 59)
               {
                  sound(200);
                  delay(100);
                  nosound();
                  break;
               }
               if((cpos < slen) && do_insert)
                  memmove((char *)s+cpos+1,(char *)s+cpos,slen-cpos);
               s[cpos] = '/';
               slen++;
               cpos++;
               s[slen] = 0;
               dprint(dx,dy,invcol,s);
               break;
     
            case '+':        //  "+" -> ":" (Fr Zeiteingabe ber Nummernblock)
               hist_act = -1;
               if(cpos > 59)
               {
                  sound(200);
                  delay(100);
                  nosound();
                  break;
               }
               if((cpos < slen) && do_insert)
                  memmove((char *)s+cpos+1,(char *)s+cpos,slen-cpos);
               s[cpos] = ':';
               slen++;
               cpos++;
               s[slen] = 0;
               dprint(dx,dy,invcol,s);
               break;

            case 132:       /* Umlaute ignorieren */
            case 142:
            case 129:
            case 154:
            case 153:
            case 148:
               break;

            default:
               if((!isalpha(ch)) && (!isdigit(ch)) && (ch!=32) && (ch!=':') && (ch!='?') && (ch!='*') && (ch!=',')) break;
               hist_act = -1;
               if(cpos > 59)
               {
                  sound(200);
                  delay(100);
                  nosound();
                  break;
               }
               if(isalpha(ch)) ch = toupper(ch);
               if(cpos < slen && do_insert)
                  memmove((char *)s+cpos+1,(char *)s+cpos,slen-cpos);
               s[cpos] = ch;
               slen++;
               cpos++;
               s[slen] = 0;
               dprint(dx,dy,invcol,s);
         }
      } while((ch!=13)&&(!shutdown));

      cp = s;

      strcpy(pattern,"*");
      print_qso(pattern,0);

      if(!shutdown&&*cp)
      {
         do
         {
            nextcp = get_next_item((unsigned char **)&cp);
 
            if(*nextcp) *(nextcp-1) = 0;
            strcpy(hist[hist_ptr],cp);
            hist_ptr++;
            if(hist_ptr>=20) hist_ptr = 0;

            done = 0;

            if(*cp == '/')
            {
               do_add(cp);
               *cp = 0;
               done++;
            };

            if((*cp=='C') && (*(cp+1)==':'))
            {
               cp+=2;
               splitcall(cp,pref,call,add);
               if(call[0])
               {
                  do_call(pref,call,add);
                  *cp = 0;
                  done++;
               };
            };

            if((*cp=='L') && (*(cp+1)==':'))
            {
               cp+=2;
               locator_state = MAN_LOC;
               calc_loc(cp);
               done++;
            };

            if(is_loc(cp)&&(!done))
            {
               locator_state = MAN_LOC;
               calc_loc(cp);
               done++;
            }

            if(valid_time(cp)&&(!done))
            {
               do_time(cp);
               *cp = 0;
               done++;
            };

            if(valid_rst(cp)&&(!done))
            {
               do_rst(cp);
               *cp = 0;
               done++;
            };

            if(valid_pattern(cp)&&(!done))
            {
               do_pattern(cp);
               *cp = 0;
               done++;
            };

            if(valid_suffix(cp)&&(!done))
            {
               do_suffix(cp);
               *cp = 0;
               done++;
            };

            if(valid_prefix(cp)&&(!done))
            {
               do_prefix(cp);
               *cp = 0;
               done++;
            };

            if(!done)
            {
               splitcall(cp,pref,call,add);
               if(call[0]) do_call(pref,call,add);
            };
 
            cp = nextcp;
         } while(*nextcp);
      }

      if(valid_qso(actual_qso)&&qso_autosave)
      {
         save_akt_qso();
         kill_akt_qso();
         dfill(dx,dy,dx+59,dy,' ',invcol);
         slen = 0;
         s[0] = 0;
         cpos = 0;
         strcpy(pattern,"*");
         print_qso(pattern,0);
      };

      dfill(1,lastline,lastrow,lastline,' ',titlecol);
      if(valid_qso(actual_qso))
      {
         dprint(75,2,(textcol&0xF0)+GREEN,"OK!");
         dprint(1,lastline,titlecol,"F1 - Help  F2/CR - Save QSO");
      }
      else
      {
         dprint(75,2,(textcol&0xF0)+RED,"---");
         dprint(1,lastline,titlecol,"F1 - Help");
      };
  
   } while(!shutdown);
};


void do_shutdown()
{
   dfill(0,0,lastrow,lastline,' ',COL(WHITE,BLACK));
   my_gotoxy(0,0);
   dend();

   switch(graphics)
   {
      case EGA:
         restore_ega_charset();
         set_blink(BLINKING);
         def_cursor(6,7);
         break;
      case VGA:
         restore_vga_charset();
         set_blink(BLINKING);
         def_cursor(6,7);
         break;
   }

   printf("  %s %s, %s by %s\n\n",PRGNAME,VERSION,DATE,AUTHOR);
   printf("This programme is (C) 1994-97 by Stefan Pfeiffer, DL1ELY@DB0IZ.\n");
   printf("Please follow the rules of LICENSE.DOC\n\n");
   
   exit(0);
};


// Zeichnet den Bildschirm von FiveNine neu...
void repaint()
{
   uchar hlp[12];
   uchar dummy[15];
   struct qso *qsop;
   struct callinfo stn_info;
   uchar i, j;
   uchar s[80];
   BOOL result;
   uchar loc[7];
   struct REGPACK r;


   error_log("repaint()","called!");
   error_log("repaint()","lastline = %d, lastrow = %d",lastline,lastrow);
   dfill(0,1,lastrow,lastline-1,' ',textcol);
   dfill(0,0,lastrow,0,' ',titlecol);
   dfill(0,lastline,lastrow,lastline,' ',titlecol);


   upcase_loc(h.ownloc);
   dprintf(1,0,titlecol,"%s  %s",h.owncall,h.ownloc);

   dprint(22,0,titlecol,"\263  contest-no.:");
   dprintf(38,0,titlecol,"%4d",h.qso_cnt+1);
   dcolor(23,0,45,0,numbercol);
   dprint(70,0,titlecol,"\263");

   dprint(59,0,titlecol,"\263 Mode:");
   switch(qso_mode)
   {
      case MODE_SSB:
         dprint(66,0,titlecol,"SSB");
         break;
      case MODE_CW:
         dprint(66,0,titlecol," CW");
         break;
      case MODE_AUR:
         dprint(66,0,titlecol,"AUR");
         break;
   };

   dprint(46,0,titlecol,"\263");
   dprintf(48,0,titlecol,"C:%2u/SQ:%2u",h.countries,h.squares);

   dprint(2,1,textcol,"Time");
   dprint(10,1,textcol,"Callsign");
   dprint(28,1,textcol,"RST snd");
   dprint(37,1,textcol,"RST rec");
   dprint(46,1,textcol,"Locator");
   dprint(58,1,textcol,"QRB");
   dprint(61,2,textcol,"km");

   dprint(66,1,textcol,"Angle");
   dprint(70,2,textcol,"\370");

   if(h.qso_cnt < 999) dprintf(32,2,textcol,"%03d",h.qso_cnt+1);
     else dprintf(31,2,textcol,"%4d",h.qso_cnt+1);

   dprintf(2,2,invcol,"%02d:%02d",fixtime?actual_qso.hour:hour,fixtime?actual_qso.min:min);
   hour = 25;
   min = 61;
  
   dcolor(10,2,24,2,invcol);
   dprint(10,2,invcol,actual_qso.call);
   dcolor(28,2,30,2,invcol);
   dprint(28,2,invcol,actual_qso.rst_TX);
   dcolor(37,2,43,2,invcol);
   dprint(37,2,invcol,actual_qso.rst_RX);
   dcolor(46,2,51,2,invcol);
   dprint(46,2,invcol,actual_qso.locator);

   // Schon Call und Locator bekannt?? Dann prfen, ob der
   // Locator zum Prfix passt.
   if(actual_prefix && actual_prefix->valid_squares && (actual_qso.locator[0]))
   {
      strcpy(hlp,actual_qso.locator);
      hlp[4] = 0;
      if(!strstr(actual_prefix->valid_squares,hlp))
         dprint(52,2,numbercol,"??");
   };


   strcpy(s," Time\263 Callsign    \263RST snd\263RST rec\263 Loc. \263Pts. ");

   dprint(0,8,titlecol,s);

   dcolor(0,6,lastrow,6,titlecol);

   dprintf(1,6,titlecol,"%6lu points\263",h.points);
   dprintf(16,6,titlecol,"%4u km/QSO\263",h.average);
   dfill(29,6,58,6,' ',titlecol);
   dprintf(29,6,titlecol,"%4u km ODX (%s)",h.ODX,h.ODX_call);
   dprint(59,6,titlecol,"\263");
   dprintf(61,6,titlecol,"%-18s",pattern);
  
   dcolor(0,7,lastrow,7,titlecol);
   dprint(1,7,titlecol,"Last hour:");
   dprint(15,7,titlecol,"QSOs");
   dprint(26,7,titlecol,"points");
   display_last_hour();
   dprint(37,7,titlecol,"km average \263 Predict.: ");
   dprint(66,7,titlecol," km      QSOs");
   dfill(48,8,lastrow,9,' ',titlecol);
   dprint(48,8,titlecol,"\263 OP:");
   strcpy(op_call,"DL1ELY");
   dprint(54,8,titlecol,op_call);
   dprint(61,8,titlecol,"\263 LOG:");
   strcpy(log_call,"DL1ELY");
   dprint(68,8,titlecol,log_call);

   dfill(0,lastline,lastrow,lastline,' ',titlecol);
   if(valid_qso(actual_qso))
   {
      dprint(75,2,(textcol&0xF0)+GREEN,"OK!");
      dprint(1,lastline,titlecol,"F1 - Help  F2/CR - Save QSO");
   }
   else
   {
     dprint(75,2,(textcol&0xF0)+RED,"---");
     dprint(1,lastline,titlecol,"F1 - Help");
   };
  
   if(actual_qso.locator[0])
   {
      // Neues ODX?
      if(actual_qso.points > h.ODX) dprint(57,3,textcol,"New ODX!  ");
  
      dprintf(56,2,textcol,"%4u",actual_qso.points);
    
      // Richtung ausgeben (Nahbereich: ---) und Richtungspfeil anzeigen
      if(actual_qso.direction <=360) dprintf(67,2,textcol,"%03u",actual_qso.direction);
         else dprint(67,2,textcol,"---");
      dprintf(72,2,textcol,"%c",get_dir_pointer(actual_qso.direction));
  
      // Locator noch nicht in der Square-Liste? Dann ist es ein neues Grofeld
      if(!actual_square) dprint(45,3,textcol,"New square!");
      // Nach QSOs mit diesem Locator suchen
      qsop = find_locator(actual_qso.locator);
      // Gefunden?? Dann in der QSO-Liste anzeigen
      if(qsop) strcpy(pattern,actual_qso.locator);
   };
  
   if(actual_qso.call[0])
   {
      if(actual_prefix)
      {
         if(actual_prefix->worked) dprint(10,3,textcol,actual_prefix->name_eng);
         else dprintf(10,3,textcol,"NEW:%s",actual_prefix->name_eng);
      }
      else dprint(10,3,textcol,"Unknown prefix!");

      qsop = find_qso(actual_qso.barecall);
      if(qsop)
      {
         dprintf(3,4,textcol,"Worked before!");
         strcpy(pattern,qsop->barecall);
         dfill(46,2,51,2,' ',invcol);
      };
    
      strcpy(dummy,actual_qso.call);
      make_norm_call(dummy,dummy);
      result = find_station(dummy,&stn_info);
      if(!result) result = find_station(actual_qso.call,&stn_info);
      //if(result) dprintf(2,4,textcol,"Info: (%s) %s",stn_info.locator,stn_info.info);
   };
  
   print_qso(pattern,0);
   if(graphics == EGA || graphics == VGA) dprint(75,8,titlecol,"\263 \001\002");

   dfill(1,4,60,4,' ',invcol);
   sprintf(hlp,"[%s]",actual_def->band);
   dprintf(79-strlen(hlp),4,numbercol,"%s",hlp);
   
   dfill(0,5,lastrow,5,' ',textcol);
   dprint(28,5,textcol,input_mode==REALTIME?"R E A L T I M E - L O G":"P O S T T I M E - L O G");

   r.r_ax = 0x4800;
   r.r_bx = 0xFFFF;
   intr(0x21,&r);
  
   dprintf(72,lastline,titlecol,"%5.1fKB",(double)farcoreleft()/1024);
};



int main(int argc, char **argv)
{
   uchar hlp[80];
   uchar choice;
   uchar ch;
   void *save;
   uchar result;
   FILE *lastf;
   int oldx,oldy;
   char *cp;
   unsigned char i;

   char load_map = 1;
   char load_database = 1;

   strcpy(fn_path,argv[0]);
   cp = fn_path+strlen(fn_path);
   while(*cp!='\\') cp--;
   cp++;
   *cp = 0;

   printf("\n");
   for(ch=1;ch<=40;ch++) putch('-');
   printf("\n%s %s, %s\n",PRGNAME,VERSION,DATE);
   printf("(C) 1994-97 by Stefan Pfeiffer, DL1ELY\n");
   for(ch=1;ch<=40;ch++) putch('-');
   printf("\n\n");

   // Speicherverw. starten
   sec_start();
   
   printf("Booting...\n");
   dstart();


   generate_path(fn_path,LAST_CONT_NAME,"\0",hlp);
   if((lastf = fopen(hlp,"rt"))==NULL)
   {
      error_log("main()","%s not found",hlp);
      dend();
      error_log("main()","DVideo Deinstallation OK");

      printf("\n%s not found, please run AUSWERT.EXE!\n\n",LAST_CONT_NAME);
      printf("This programme is (C) 1994-96 by Stefan Pfeiffer, DL1ELY@DB0IZ.\n");
      printf("Please follow the rules of LICENCE.DOC.\n\n");

      error_log("main()","Abort");
      exit(0);
   };

   fgets(defname,256,lastf);
   if(defname[strlen(defname)-1] == '\n') defname[strlen(defname)-1] = 0;
   fclose(lastf);
   error_log("main()","LastCont = %s",defname);
 
   for(i=1;i<argc;i++)
   {
      strcpy(hlp,argv[i]);
      if(hlp[0]!='-')
      {
         strcpy(defname,hlp);
         strupr(defname);
         cp = strchr(defname,'.');
         if(!cp) strcat(defname,".DES");
         error_log("main()","Commandline = %s",defname);
      };
   };
 
   error_log("main()","Reading Config");
   if(!read_config_file())
   {
      error_log("main()","Config not found");
      dend();
      error_log("main()","DVideo Deinstallation OK");
      printf("\n%s not found, please run AUSWERT.EXE!\n\n",CONFIG_NAME);
      printf("This programme is (C) 1994-95 by Stefan Pfeiffer, DL1ELY@DB0IZ.\n");
      printf("Please follow the rules of LICENCE.DOC.\n\n");

      error_log("main()","Abort");
      exit(0);
   };

   for(i=1;i<argc;i++)
   {
      strcpy(hlp,argv[i]);
      if(hlp[0] == '-')
      {
         strupr(hlp);
         cp = (hlp+1);
         error_log("main()","Option = %s",cp);
//         if(!strcmp(cp,"EMS")) use_ems = 1;
//         if(!strcmp(cp,"NOEMS")) use_ems = 0;
//         if(!strcmp(cp,"XMS")) use_xms = 1;
//         if(!strcmp(cp,"NOXMS")) use_xms = 0;
         if(!strcmp(cp,"NOSVGA")) svgamode = 0;
         if(!strcmp(cp,"NOUMB")) use_umb = 0;
         if(!strcmp(cp,"UMB")) use_umb = 1;
         if(!strcmp(cp,"NOBASE")) load_database = 0;
         if(!strcmp(cp,"NOMAP")) load_map = 0;
      };
   };


   error_log("main()","Determining graphicscard");
   get_graphics();
   switch(graphics)
   {
      case EGA:
         error_log("main()","EGA");
         printf("EGA");
         ega_setchars();
         set_blink(do_blink);
         def_cursor(0,7);
         error_log("main()","Installing EGAVGA-Driver");
         registerfarbgidriver(EGAVGA_driver_far);
         break;
      case VGA:
         error_log("main()","VGA");
         printf("VGA");
         vga_setchars();
         set_blink(do_blink);
         def_cursor(0,7);
         error_log("main()","Installing EGAVGA-Driver");
         registerfarbgidriver(EGAVGA_driver_far);
         if(svgamode)
         {
            printf(", 800x600-Mode 0x%02X",svgamode);
            error_log("main()","Patching Driver (0x%02X)",svgamode);
            patch_driver(svgamode);
         };
         break;
      case HERCMONO:
         error_log("main()","Hercules");
         printf("Hercules");
         break;
      case ATT400:
         error_log("main()","AT&T");
         printf("AT&T");
         break;
      default:
         error_log("main()","CGA/MDA");
         printf("CGA/MDA");
         break;
   }
   printf("\n");
  
   error_log("main()","Determining OS");
   printf("OS: ");
   if(is_windows()) printf("Windows");
   else if(is_os2()) printf("OS/2");
   else printf("DOS");
  
   printf("\n\n");
/*   if(xms_inst)
   {
      printf("XMS found,");
      if(use_xms) printf(" in use!\n");
      else printf(" not used!\n");
   }
   else printf("No XMS found!\n");

   if(ems_inst)
   {
      printf("EMS found,");
      if(use_ems) printf(" in use!\n");
      else printf(" not used!\n");
   }
   else printf("No EMS found!\n");*/


   pio_init();
   if(rotor)
   {
      if(!pio_port[rotor-1]) rotor = 0;
   };

   for(i=0;i<3;i++)
   {
      if(pio_port[i])
      {
         printf("\nLPT%u: %04X",i+1,pio_port[i]);
         error_log("main()","LPT%u: %04X",i+1,pio_port[i]);
      }
      else
      {
         printf("\nLPT%u: Not found!",i+1);
         error_log("main()","LPT%u: Not found!",i+1);
      };
   };
 
//   comm_init(comm_lines);
//   tnc_init();

   printf("\n\nStart logging...\n");
   
   load_prediction_data();
   

   oldx = wherex();
   oldy = wherey();

   oldx--;
   oldy--;

   error_log("main()","Saving Screen");
   save = dsave(0,0,lastrow,lastline);

   error_log("main()","Painting screen");
   my_gotoxy(80,lastline+1);
   dclrscr(textcol);
   dcolor(0,0,lastrow,0,titlecol);

   sprintf(hlp,"%s %s by %s, %s",PRGNAME,VERSION,AUTHOR,DATE);
   dprintf((lastrow+1-strlen(hlp))/2,0,titlecol,hlp);

   if(!defname[0])
   {
      error_log("main()","No Contestfile given");
      sprintf(hlp,"No filename given, please run AUSWERT.EXE!");
      ok_box("fatal error",hlp);
      error_log("main()","Shutting down");
      sec_free(save);
      do_shutdown();
   };

   error_log("main()","Loading file %s",defname);
   if(!load_definitions(defname,date,title))
   {
      error_log("main()","File %s not found",defname);
      sprintf(hlp,"%s not found - please run AUSWERT.EXE!",defname);
      ok_box("fatal error",hlp);
      error_log("main()","Shutting down");
      sec_free(save);
      do_shutdown();
   };

   error_log("main()","Loading Bands");
   load_all_definitions();
   error_log("main()","Bands OK");

   error_log("main()","Loading database");
   if(load_database) load_call_index();
   error_log("main()","database OK");
   error_log("main()","Loading mapdata");
   if(load_map) load_map_data();
   error_log("main()","mapdata OK");


   error_log("main()","Initializing Bands");
   for(actual_def = firstdef;actual_def;actual_def = actual_def->next)
   {
      memset((void *)&actual_def->act_qso,0,QSO_SIZE);
      switch(qso_mode)
      {
         case MODE_SSB:
            strcpy(actual_qso.rst_TX," 59");
            break;
         case MODE_CW:
            strcpy(actual_qso.rst_TX,"599");
            break;
         case MODE_AUR:
            strcpy(actual_qso.rst_TX,"59A");
            break;
      };
 
      actual_def->act_prefix = NULL;
      actual_def->act_square = NULL;
      actual_def->loc_state = 0;
      actual_def->fixtime = 0;
      strcpy(actual_def->pattern,"*");
   };

   error_log("main()","Band Initialization OK");
 
   error_log("main()","Enabling first band");
   actual_def = firstdef;
   enable_band(actual_def,1);
   
   updatetime();
  
   error_log("main()","Start Logging...");
   do_logging();
   error_log("main()","Logging OK");

   error_log("main()","Freeing database");
   kill_all_calls();
   error_log("main()","Database OK");

   error_log("main()","Freeing definitions");
   kill_definitions();
   error_log("main()","Definitions OK");

//   tnc_deinit();
   error_log("main()","TNC-Deinitialization OK...");

//   comm_end();
   error_log("main()","Communcation-Deinitialization OK...");

   error_log("main()","Freeing map-data");
   free_map_data();
   error_log("main()","Map OK");

  
   error_log("main()","Resetting Graphicscard");
   switch(graphics)
   {
      case EGA:
         restore_ega_charset();
         set_blink(BLINKING);
         def_cursor(6,7);
         break;
      case VGA:
         restore_vga_charset();
         set_blink(BLINKING);
         def_cursor(6,7);
         break;
   }
   error_log("main()","Graphicscard OK");


   dend();

   drestore(save);
   sec_free(save);
           
   my_gotoxy(oldx,oldy);

   textcolor(WHITE);
   textbackground(BLACK);

   printf("\nThis programme is (C) 1994-97 by Stefan Pfeiffer, DL1ELY@DB0IZ.\n");
   printf("Please follow the rules of LICENCE.DOC.\n\n");

   return(0);
};


