// FIVENINE.H - Definitions for FIVENINE.C
// Written by Stefan Pfeiffer, DL1ELY, 940213
// Last Modification: 960222
// (C) 1994 by Stefan Pfeiffer, DL1ELY@DB0PKE


#ifndef FIVENINE_H


#define FIVENINE_H


#include <stdio.h>
#include <conio.h>
#include "global.h"
#include "structs.h"
#include "locator.h"
#include "dvideo.h"
#include "wildmat.h"
#include "egavga.h"
#include "input.h"
#include "database.h"
#include "map.h"
#include "config.h"
#include "stat.h"
#include "pcx.h"
#include "wave.h"
#include "tools.h"
#include "multibnd.h"
#include "pio.h"
#include "comm.h"
#include "sio.h"
#include "secmem.h"
#include <ctype.h>
#include <dos.h>
#include <string.h>
#include <stdlib.h>
#include <alloc.h>
#include <graphics.h>


#define PRGNAME "FiveNine"
#define VERSION "v1.60"
#define AUTHOR  "Stefan Pfeiffer, DL1ELY"
#define DATE    "960611"

// ACHTUNG!! Hngt vom Fileformat ab!
#define FILEBYTE_PER_QSO  56


/* Not yet implemented!!
typedef struct
{
  struct cityinfo far *next;
  struct cityinfo far *prev;
  
  pchar name;
  double east;
  double north;
} cityinfo;
*/
  
  
typedef struct coord
{
  char loc[5];
  int X, Y;
};


//#define NULLcityinfo   (struct cityinfo *)0

#define NO_LOC    0
#define MAN_LOC   1
#define DB_LOC    2
#define GUESS_LOC 3

#define CALL_COMPLETE  0
#define PREFIX_MISS    1
#define SUFFIX_MISS    2
#define CALL_MISS      3

extern BOOL lang;

extern char call_incomplete;

extern char stupid_user;

extern double own_north;
extern double own_east;

extern struct qso actual_qso;
extern struct countryinfo far *actual_prefix;
extern BOOL locator_state;
extern struct squareinfo far *actual_square;
extern BOOL qso_mode;

extern BOOL shutdown;
extern BOOL fixtime;

extern uchar hour;
extern uchar min;
extern uchar sec;

extern uchar pref[4];
extern uchar call[14];
extern uchar add[3];

extern uchar pattern[21];

extern uchar cntname[128];

#define NO_SCROLL   0
#define SAVE_SCROLL 1
#define PERM_SCROLL 2

extern BOOL do_scrolling;
extern pchar scp;
extern uchar scroll_text[81];
extern BOOL scroll;

extern unsigned long *sys_timer;
extern unsigned long old_timer;
extern unsigned long last_key;
extern unsigned inact_time;

extern uchar pointers[9];
extern BOOL do_insert;
extern BOOL do_sound;
extern BOOL qso_autosave;
extern uchar svgamode;
extern BOOL do_blink;

extern unsigned char use_ems;
extern unsigned char use_xms;

extern uchar fn_path[128];
extern uchar defname[128];

extern BOOL do_bar_stat;
extern unsigned checkloc;
extern uchar printport;
extern uchar pr_lines;


void out_of_mem(void);

uchar get_dir_pointer(unsigned);

unsigned time2min(uchar, uchar);
void guess_locator(pchar,pchar);
void calc_loc(pchar);
BOOL valid_time(pchar);
void do_time(pchar);

void write_a_qso(struct qso,FILE *);
void print_empty_line(uchar);
void print_qso(pchar, char);
void do_suffix(pchar);
void do_call(pchar,pchar,pchar);
pchar get_next_item(ppchar);
BOOL valid_rst(pchar);
void do_rst(pchar);
void updatetime(void);
void kill_akt_qso(void);
void save_akt_qso(void);
BOOL valid_pattern(pchar);
void do_pattern(pchar);
void show_map(void);
void do_menu(void);
uchar read_config_file(void);
void do_qso_edit(void);
void print_qso_line(struct qso far *, uchar);
void do_logging(void);
void do_shutdown(void);
void find_ODX(void);
void calc_points(void);
void calc_squares(void);
void calc_countries(void);
BOOL valid_qso(struct qso);
void repaint(void);
void display_last_hour(void);

extern int far EGAVGA_driver_far[];
extern int far Herc_driver_far[];
extern int far ATT_driver_far[];

#endif



