// MMANAGER.H - Headerfile for MMANAGER.C
// Written by Stefan Pfeiffer, DL1ELY, 941014
// Last midification: 950228
// (C) 1994 by Stefan Pfeiffer, DL1ELY

#ifndef MMANAGER_H

#define MMANAGER_H

#include <dos.h>
#include <string.h>
#include <stdio.h>
#include <alloc.h>

#include "tools.h"


#define MM_NAME  "MManager"
#define MM_VER   "v1.01b"
#define MM_DATE  "950228"


#define EMM_INT  0x67
#define EMM_SIG  "EMMXXXX0"

#define XMS_INT  0x2F
#define PAGESIZE 0x4000

#define DOS_INT    0x21
#define USE_UMB    0x80
#define FIRST_FIT  0x00
#define BEST_FIT   0x01
#define LAST_FIT   0x02


// Speicherarten
#define NONE 0
#define RAM  1
#define EMS  2
#define XMS  3
#define UMB  4
#define HMA  5


// Variablen fr DOS
extern unsigned char dos_umb_link;
extern unsigned char dos_mem_alloc;

// Variablen fr EMS
extern void far *ems_frame[4];
extern unsigned char ems_ver_lo, ems_ver_hi;
extern unsigned char ems_inst;

// Variablen fr XMS
struct xms_cb
{
  unsigned long size;
  unsigned int src_handle;
  unsigned long src_ofs;
  unsigned int dest_handle;
  unsigned long dest_ofs;
};

extern void far *xms_page;
extern unsigned char xms_page_type;

extern unsigned char xms_inst;
extern void far (*xms_service)(void);

extern unsigned char xms_ver_hi, xms_ver_lo;
extern unsigned char xms_rev_hi, xms_rev_lo;
extern unsigned char xms_hma_found;


// Allgemeine Funktionen
void mm_start(void);
void mm_end(void);


// Funktionen fr EMS
unsigned ems_get_free_pages(void);
unsigned ems_alloc(unsigned);
void ems_setmap(unsigned, unsigned, unsigned char);
void ems_free(unsigned);


// Funktionen fr XMS
void xms_alloc_swaparea(void);
void xms_free_swaparea(void);
unsigned int xms_get_free(void);
unsigned char xms_alloc_hma(void);
void xms_free_hma(void);
unsigned int xms_alloc_umb(unsigned int);
void xms_free_umb(unsigned int);
unsigned int xms_alloc(unsigned int);
void xms_free(unsigned int);
void xms_moveto(void far *, unsigned int, unsigned long, unsigned long);
void xms_movefrom(unsigned int, unsigned long, void far *,unsigned long);

// Funktionen fr DOS-far-alloc
unsigned dos_get_free_mem(void);
unsigned dos_alloc(unsigned);
void dos_free(unsigned);

#endif

