
// STAT.C - Statistical functions
// Written by Stefan Pfeiffer, DL1ELY, 941125
// Last modification: 951031
// (C) 1994 by Stefan Pfeiffer, DL1ELY


#include <graphics.h>
#include "global.h"
#include "stat.h"
#include "structs.h"
#include "dvideo.h"
#include "database.h"
#include "input.h"
#include "egavga.h"
#include "locator.h"
#include "map.h"
#include "pio.h"
#include "secmem.h"
#include <string.h>
#include <conio.h>
#include <math.h>
#include <dos.h>

extern unsigned char printport;
extern char *fn_path;

extern struct call_index *calls;
extern struct multi_index *multis;
extern struct loc_index *locator;



void disp_stn_data()
{
   void *save;
   FILE *f;
   char hlp[128];
   char s[128];
   unsigned cnt = 0;
   unsigned int point_data[48];
   unsigned int qso_data[48];
   unsigned y, i;
   unsigned old_y_points, old_y_qsos;
   unsigned old_x;
   float ratio;
   int bar_ratio;


   if(!graphics) return;


   generate_path(fn_path,STN_DATA_NAME,"",hlp);
   f = fopen(hlp,"rb");

   if(!f)
   {
      ok_box("Error","There were no contest-infos gathered up to now!");
      return;
   };

   fread(&cnt,1,2,f);
   fread(point_data,1,sizeof(point_data),f);
   fread(qso_data,1,sizeof(qso_data),f);

   fclose(f);

   graph_mode();


   ratio = (float)((float)(ymax-60)/0xFFFF);
   bar_ratio = (int)(xmax-80)/47;

   setfillstyle(SOLID_FILL,BLACK);
   bar(0,0,xmax,ymax);

   setcolor(maptextcol);
   if(cnt == 1) sprintf(s,"QSOs and points in one former contest");
   else sprintf(s,"QSOs and points in %d former contests",cnt);
   outtextxy((xmax-textwidth(s))/2,2,s);

   setcolor(maptextcol);
   setlinestyle(SOLID_LINE,0,1);
   line(50,ymax-40,xmax-30,ymax-40);
   line(50,20,50,ymax-40);
   line(xmax-30,20,xmax-30,ymax-40);
  
   setcolor(mapcol);
   setlinestyle(DOTTED_LINE,0,1);

   for(i=10;i<=90;i+=10)
   {
      sprintf(s,"%2d",i);
      y = ymax-40-(i*(ymax-60)/100);
      line(51,y,xmax-31,y);
      outtextxy(xmax-textwidth(s),y-3,s);
   };
   line(51,20,xmax-31,20);
   strcpy(s,"100");
   outtextxy(xmax-textwidth(s),17,s);
   strcpy(s,"Percent");
   outtextxy(xmax-textwidth(s)-3,5,s);

   setlinestyle(SOLID_LINE,0,3);
   setcolor(mapcol);
   line(70,35,70+(2*bar_ratio),35);
   setcolor(maptextcol);
   pieslice(70,35,0,360,2);
   pieslice(70+bar_ratio,35,0,360,2);
   pieslice(70+(2*bar_ratio),35,0,360,2);
   outtextxy(78+(2*bar_ratio),33,"= Points");

   line(70,55,70+(2*bar_ratio),55);
   setcolor(mapcol);
   pieslice(70,55,0,360,2);
   pieslice(70+bar_ratio,55,0,360,2);
   pieslice(70+(2*bar_ratio),55,0,360,2);
   setcolor(maptextcol);
   outtextxy(78+(2*bar_ratio),53,"= QSOs");


   old_x = 0;
   for(i=0;i<48;i++)
   {
      if(!(i&1) && (i>0))
      {
         setcolor(mapcol);
         setlinestyle(DOTTED_LINE,0,1);
         line(old_x+50,old_y_points<old_y_qsos?old_y_points:old_y_qsos,old_x+50,ymax-41);
      };


      if(!i) old_y_points = ymax-40;

      setcolor(mapcol);
      setlinestyle(SOLID_LINE,0,3);
      line(old_x+50,old_y_points,old_x+50+bar_ratio,ymax-40-(point_data[i]*ratio));

      setcolor(maptextcol);
      setfillstyle(SOLID_FILL,maptextcol);
      pieslice(old_x+50,old_y_points,0,360,2);


      if(!i) old_y_qsos = ymax-40;

      setcolor(maptextcol);
      setlinestyle(SOLID_LINE,0,3);
      line(old_x+50,old_y_qsos,old_x+50+bar_ratio,ymax-40-(qso_data[i]*ratio));

      setcolor(mapcol);
      setfillstyle(SOLID_FILL,mapcol);
      pieslice(old_x+50,old_y_qsos,0,360,2);


      old_y_qsos = ymax-40-(qso_data[i]*ratio);
      old_y_points = ymax-40-(point_data[i]*ratio);

      if(!(i&1))
      {
         settextstyle(0,HORIZ_DIR,1);
         settextjustify(LEFT_TEXT,TOP_TEXT);
         setcolor(maptextcol);
         if(i<20) sprintf(s,"%02d",(i>>1)+14);
         else sprintf(s,"%02d",(i>>1)-10);
         outtextxy(old_x+50-(textwidth(s)>>1),ymax-35,s);
      };

      old_x+=bar_ratio;
   };

   setcolor(maptextcol);
   setfillstyle(SOLID_FILL,maptextcol);
   pieslice(old_x+50,old_y_points,0,360,2);

   setcolor(maptextcol);
   outtextxy((48*bar_ratio)+50-(textwidth("14")>>1),ymax-35,"14");
 
   outtextxy(32-textwidth("UTC"),ymax-34,"UTC");
  

   setcolor(maptextcol);
   outtextxy(10,ymax-8,"any key...");
   outtextxy((xmax/2)+10,ymax-8,"FiveNine by Stefan Pfeiffer, DL1ELY");

   if(!getch()) getch();

   text_mode();
   my_gotoxy(80,lastline+1);
};


void add_stn_data()
{
   struct qso *q;
   unsigned i, pos;
   unsigned qsos[48];
   unsigned long points[48];
   unsigned cnt;
   unsigned qso_data[48];
   unsigned point_data[48];
   char hlp[128];
   double ratio;
   FILE *f;


   memset(qsos,0,sizeof(qsos));
   memset(points,0,sizeof(points));

   q = firstqso;
   while(q)
   {
      if(q->hour<14) pos = 20+(q->hour<<1);
      else pos = (q->hour-14)<<1;
      if(q->min>=30) pos++;
      for(i=pos;i<48;i++)
      {
         qsos[i]++;
         points[i]+=q->points;
      };
      q = q->next;
   };

   for(i=0;i<48;i++)
   {
      qsos[i] = (unsigned)(qsos[i]/(double)h.qso_cnt*0xFFFF);
      points[i] = (unsigned)(points[i]/(double)h.points*0xFFFF);
   };

   generate_path(fn_path,STN_DATA_NAME,"",hlp);
   f = fopen(hlp,"rb");

   cnt = 0;
   memset(point_data,0,sizeof(point_data));
   memset(qso_data,0,sizeof(qso_data));

   if(f)
   {
      fread(&cnt,1,2,f);
      fread(point_data,1,sizeof(point_data),f);
      fread(qso_data,1,sizeof(qso_data),f);

      fclose(f);
   };

   if(!cnt)
   {
      cnt++;
      for(i=0;i<48;i++)
      {
         point_data[i] = points[i];
         qso_data[i] = qsos[i];
      };
   }
   else
   {

      for(i=0;i<48;i++)
      {
         ratio = (double)point_data[i]*cnt;
         ratio/=(cnt+1);
         ratio+=((double)points[i]/(cnt+1));
         point_data[i] = ratio;

         ratio = (double)qso_data[i]*cnt;
         ratio/=(cnt+1);
         ratio+=((double)qsos[i]/(cnt+1));
         qso_data[i] = ratio;
      };
      cnt++;
   };   

   f = fopen(hlp,"wb");
      
   fwrite(&cnt,1,2,f);
   fwrite(point_data,1,sizeof(point_data),f);
   fwrite(qso_data,1,sizeof(qso_data),f);
      
   fclose(f);

   ok_box("Hint","The contest has been added to the base of prediction!");
};


// Statistik ber die besten Grofelder nach QSOs/Punkten
void do_top_squares()
{
   void *save;
   uchar i;
   unsigned long max;
   unsigned long border;
   struct squareinfo *sq;

   save = dsave(0,0,79,lastline);

   dfill(0,0,79,lastline,' ',textcol);

   dprint(2,1,textcol,"Best squares by QSO:");
   i = 3;
   border = 65000;

   do
   {
      max = 0;

      sq = firstsquare;
      while(sq)
      {
         if(sq->worked > max && sq->worked < border) max = sq->worked;
         sq = sq->next;
      };

      if(max)
      {
         sq = firstsquare;
         while(sq && i<lastline)
         {
            if(sq->worked == max)
            {
               dprintf(5,i,textcol,"%s:%3d QSO%c",sq->name,sq->worked,sq->worked>1?'s':' ');
               i++;
            };
            sq = sq->next;
         };
         border = max;
       };
   } while (max && i<lastline);

   dfill(39,0,39,lastline,179,textcol);
   dprint(42,1,textcol,"Best squares by points:");
   i = 3;
   border = 100000;

   do
   {
      max = 0;

      sq = firstsquare;
      while(sq)
      {
         if(sq->points > max && sq->points < border) max = sq->points;
         sq = sq->next;
      };

      if(max)
      {
         sq = firstsquare;
         while(sq && i<lastline)
         {
            if(sq->points == max)
            {
               dprintf(45,i,textcol,"%s:%6ld %s",sq->name,sq->points,"points");
               i++;
            };
            sq = sq->next;
         };
         border = max;
      };
   } while (max && i<lastline);

   if(!getch()) getch();
   drestore(save);
   sec_free(save);
};

 
// Statistik ber die Verteilung der Entfernungen
void do_distances()
{
   unsigned qsos[21];
   unsigned long points[21];
   unsigned char pos;
   struct qso *q;
   unsigned long i;
   unsigned y;
   unsigned max_qso = 0;
   unsigned long max_point = 0;
   float qso_ratio;
   float point_ratio;
   unsigned bar_ratio;
   uchar s[60];
   unsigned old_x;
   uchar ch;

  
   memset(qsos,0,sizeof(qsos));
   memset(points,0,sizeof(points));

   q = firstqso;
   while(q)
   {
      if(q->points > 0)
      {
         pos = (unsigned char)(q->points/50);
         if(pos > 20) pos = 20;
         qsos[pos]++;
         points[pos]+=q->points;
      };
      q = q->next;
   };
  
   for(i=0;i<21;i++)
   {
      if(qsos[i]>max_qso) max_qso = qsos[i];
      if(points[i]>max_point) max_point = points[i];
   };
  
   graph_mode();
  
   setcolor(maptextcol);
   line(50,ymax-30,xmax-30,ymax-30);
   line(50,20,50,ymax-30);
   line(xmax-30,20,xmax-30,ymax-30);

   setcolor(maptextcol);
   strcpy(s,"QSOs and points by covered distances");
   outtextxy((xmax-textwidth(s))/2,2,s);
  
   if(max_qso)
   {
      qso_ratio = (float)((float)(ymax-70)/max_qso);
      point_ratio = (float)((float)(ymax-50)/max_point);
      bar_ratio = (int)(xmax-80)/21;
  
      setcolor(bordercol);
      for(i=0;i<=max_qso;i+=5)
      {
         sprintf(s,"%2d",i);
         y = ymax-30-(i*qso_ratio);
         setlinestyle(SOLID_LINE,0,1);
         line(xmax-29,y,xmax-22,y);
         if(i)
         {
            setlinestyle(DOTTED_LINE,0,1);
            line(51,y,xmax-31,y);
         };
         outtextxy(xmax-20,y-3,s);
      };
  
      sprintf(s,"%2d",max_qso);
      y = ymax-30-(max_qso*qso_ratio);
      setlinestyle(SOLID_LINE,0,1);
      line(xmax-29,y,xmax-22,y);
      outtextxy(xmax-20,y-3,s);
  
      outtextxy(xmax-27,5,"QSOs");
  
  
      setcolor(mapcol);
      for(i=0;i<=max_point;i+=max_point<15000?500:1000)
      {
         sprintf(s,"%5d",i);
         y = ymax-30-(i*point_ratio);
         setlinestyle(SOLID_LINE,0,1);
         line(42,y,49,y);
         if(i)
         {
            setlinestyle(DOTTED_LINE,0,1);
            line(51,y,xmax-31,y);
         };
         outtextxy(1,y-3,s);
      };
  
      sprintf(s,"%5d",max_point);
      y = ymax-30-(max_point*point_ratio);
      setlinestyle(SOLID_LINE,0,1);
      line(42,y,49,y);
      outtextxy(1,y-3,s);
  
      outtextxy(1,5,"pts.");

      for(i=0;i<21;i++)
      {
         qsos[i] = qsos[i]*qso_ratio;
         points[i] = points[i]*point_ratio;
      };
    
      old_x = 50;
      i = 0;
      settextjustify(CENTER_TEXT,TOP_TEXT);
      while(i<21)
      {
         setcolor(mapcol);
         setfillstyle(SOLID_FILL,mapcol);
         bar(old_x+2,ymax-30-points[i],
             old_x+(bar_ratio/2)-1,ymax-30);
    
         setcolor(bordercol);
         setfillstyle(SOLID_FILL,bordercol);
         bar(old_x+(bar_ratio/2)+1,ymax-30-qsos[i],
             old_x+bar_ratio-2,ymax-30);
      
         setcolor(maptextcol);
         line(old_x,ymax-30,old_x,ymax-15);
         sprintf(s,"%d",i*50);
         if(i<20)
         {
            outtextxy(old_x+(bar_ratio/2),ymax-25,s);
            outtextxy(old_x+(bar_ratio/2),ymax-17,"-");
            sprintf(s,"%d",(i+1)*50);
            outtextxy(old_x+(bar_ratio/2),ymax-10,s);
         }
         else
         {
            outtextxy(old_x+(bar_ratio/2)+3,ymax-25,s);
            outtextxy(old_x+(bar_ratio/2)+3,ymax-17,"-");
         };

         old_x+=bar_ratio;
         i++;
      };
   };

   ch = getch();
   if(toupper(ch) == 'P') pio_print_screen(printport);
   if(!ch) getch();
  
   text_mode();
   my_gotoxy(80,lastline+1);
};

// Zeigt eine Textgrafik der gearbeiteten Grofelder an.
void do_square_map()
{
   struct squareinfo *hlp;
   void *save;

   uchar nw_col;
   uchar w_col;
   uchar my_col;
   char own_field[7];
   int own_x, own_y;
   int min_x, min_y;
   uchar X;
   uchar Y;
   uchar loc[7];
   uchar s[10];
   uchar col;
  
   nw_col = (textcol & 0xF0) + DARKGRAY;
   w_col  = (textcol & 0xF0) + YELLOW;
   my_col = (textcol & 0xF0) + RED;
  
   strcpy(own_field,h.ownloc);
   own_field[4] = 0;

   loc2rel(own_field,&own_x,&own_y);
   min_x = own_x - ((lastrow+1)/10);
   min_y = own_y - 11;
  
   save = dsave(0,0,lastrow,lastline);

   dfill(0,0,lastrow,lastline,' ',textcol);

  
   for(Y=0;Y<lastline-1;Y++)
   {
      for(X=0;X<(lastrow+1)/5;X++)
      {
         rel2loc(min_x+X,min_y+Y,loc);
         hlp = find_square(loc);
         if(hlp)
         {
            sprintf(s,"%4d",hlp->worked);
            col = w_col;
            if(!strcmp(loc,own_field)) col = my_col;
            dprint(X*5,Y,col,s);
         }
         else
         {
            col = nw_col;
            if(!strcmp(loc,own_field)) col = my_col;
            dprint(X*5,Y,col,loc);
         };
      };
   };
  
   dprintf(2,lastline-1,textcol,"%d QSO%s with %d square%s",h.qso_cnt,h.qso_cnt!=1?"s":"",h.squares,h.squares!=1?"s":"");
   dprint(36,lastline,textcol,"any key");
  
   if(!getch()) getch();
  
   drestore(save);
   sec_free(save);
};


#define DIR_POINTS  0
#define DIR_QSOS    1
#define DIR_AVERAGE 2

// Zeigt eine Statistik der Richtungen an.
void do_dir_stat()
{
   struct qso *q;

   unsigned long points[72];
   unsigned qsos[72];
   unsigned average[72];

   unsigned coord[146];

   unsigned long max_points;
   unsigned max_qsos;
   unsigned max_average;
   unsigned max;

   uchar stat_mode = DIR_POINTS;

   void *save;
   float bogen;
   unsigned i;
   BOOL paint;

   float point_ratio;
   float qso_ratio;
   float average_ratio;
   float ratio;

   uchar s[80];
   uchar ch;
   unsigned abschnitt;

  
   if(!(h.qso_cnt-h.invalid)) return;
  
   memset(points,0,sizeof(points));
   memset(qsos,0,sizeof(qsos));
   memset(average,0,sizeof(average));
   memset(coord,0,sizeof(coord));
  
   q = firstqso;
   while(q)
   {
      if(q->direction<360)
      {
         points[q->direction/5]+=q->points;
         qsos[q->direction/5]++;
      };
      q = q->next;
   };

   max_average = 0;
   for(i=0;i<72;i++)
   {
      if(qsos[i]) average[i] = (unsigned)(points[i]/qsos[i]);
      if(average[i]>max_average) max_average = average[i];
   };
   average_ratio = (float)((float)(ymax-20)/2/(float)max_average);

   max_points = 0;
   for(i=0;i<72;i++) if(points[i]>max_points) max_points = points[i];
   point_ratio = (float)((float)(ymax-20)/2/(float)max_points);

   max_qsos = 0;
   for(i=0;i<72;i++) if(qsos[i]>max_qsos) max_qsos = qsos[i];
   qso_ratio = (float)((float)(ymax-20)/2/(float)max_qsos);

   save = dsave(0,0,lastrow,lastline);
  
   graph_mode();
  
   do
   {
      setfillstyle(SOLID_FILL,BLACK);
      bar(0,0,xmax,ymax);

      setcolor(bordercol);

      for(i=0;i<72;i++)
      {
         switch(stat_mode)
         {
            case DIR_POINTS:
               if(points[i])
               {
                  bogen = (float)((float)(i*5)/180*M_PI);
                  coord[i*2] = xmax/2+(int)(sin(bogen)*points[i]*point_ratio);
                  coord[(i*2)+1] = ymax/2-(int)(cos(bogen)*points[i]*point_ratio);
               }
               else
               {
                  coord[i*2] = xmax/2;
                  coord[(i*2)+1] = ymax/2;
               };
               break;

            case DIR_QSOS:
               if(qsos[i])
               {
                  bogen = (float)((float)(i*5)/180*M_PI);
                  coord[i*2] = xmax/2+(int)(sin(bogen)*qsos[i]*qso_ratio);
                  coord[(i*2)+1] = ymax/2-(int)(cos(bogen)*qsos[i]*qso_ratio);
               }
               else
               {
                  coord[i*2] = xmax/2;
                  coord[(i*2)+1] = ymax/2;
               };
               break;

            case DIR_AVERAGE:
               if(average[i])
               {
                  bogen = (float)((float)(i*5)/180*M_PI);
                  coord[i*2] = xmax/2+(int)(sin(bogen)*average[i]*average_ratio);
                  coord[(i*2)+1] = ymax/2-(int)(cos(bogen)*average[i]*average_ratio);
               }
               else
               {
                  coord[i*2] = xmax/2;
                  coord[(i*2)+1] = ymax/2;
               };
               break;
         };
      };
      coord[144] = coord[0];
      coord[145] = coord[1];

      setfillstyle(SOLID_FILL,bordercol);
      fillpoly(73,(int far *)coord);

      setcolor(mapcol);
      line(10,ymax/2,xmax-10,ymax/2);
      line(xmax/2,20,xmax/2,ymax-20);

      switch(stat_mode)
      {
         case DIR_POINTS:
            abschnitt = 100;
            while((max_points/abschnitt)>10) abschnitt+=100;
            max = max_points;
            ratio = point_ratio;
            break;
         case DIR_QSOS:
            abschnitt = 2;
            while((max_qsos/abschnitt)>10) abschnitt+=2;
            max = max_qsos;
            ratio = qso_ratio;
            break;
         case DIR_AVERAGE:
            abschnitt = 10;
            while((max_average/abschnitt)>10) abschnitt+=10;
            max = max_average;
            ratio = average_ratio;
            break;
      };

      for(i=abschnitt;i<max;i+=abschnitt)
         circle(xmax/2,ymax/2,(int)(ratio*i));
  
      setcolor(maptextcol);
      switch(stat_mode)
      {
         case DIR_POINTS:
            strcpy(s,"Points in dependency of the direction");
            break;
         case DIR_QSOS:
            strcpy(s,"QSOs in dependency of the direction");
            break;
         case DIR_AVERAGE:
            strcpy(s,"Average points per QSO in dependency of the direction");
            break;
      };
      outtextxy((xmax-textwidth(s))/2,5,s);
  
      setcolor(maptextcol);
      switch(stat_mode)
      {
         case DIR_POINTS:
            sprintf(s,"1 circle = %d points",abschnitt);
            break;
         case DIR_QSOS:
            sprintf(s,"1 circle = %d QSOs",abschnitt);
            break;
         case DIR_AVERAGE:
            sprintf(s,"1 circle = %d points/QSO",abschnitt);
            break;
      };
      outtextxy(20,ymax-22,s);
      outtextxy(20,ymax-10,"any key...");
      outtextxy(20+(xmax/2),ymax-22,"  = Points/QSOs/Average");
      outtextxy(20+(xmax/2),ymax-10,"FiveNine by Stefan Pfeiffer, DL1ELY");

      paint=0;
      do
      {
         ch = getch();
         if(toupper(ch) == 'P') pio_print_screen(printport);
         if(ch == 27) paint=1;
         if(ch == 32)
         {
            ch=27;
            paint=1;
         };
         if(ch == 13)
         {
            ch = 27;
            paint=1;
         };

         if(!ch)
         {
            ch = getch();
            switch(ch)
            {
               case 80:
                  paint = 1;
                  if(stat_mode>0) stat_mode--;
                  else stat_mode = DIR_AVERAGE;
                  break;
               case 72:
                  paint = 1;
                  stat_mode++;
                  if(stat_mode > DIR_AVERAGE) stat_mode = DIR_POINTS;
                  break;
             };
         };
      } while(!paint);

   } while(ch!=27);

   text_mode();
   drestore(save);
   sec_free(save);
   my_gotoxy(80,lastline+1);
};

// zeigt eine Statistik ber die gearbeiteten Lnder an.
void do_country_stat()
{
   struct countryinfo *hlp;
   void *save;
   uchar y;
   unsigned border;
   unsigned max;
   float prozent;

   save = dsave(0,0,79,lastline);
  
   dfill(0,0,79,lastline,' ',textcol);
   dprint(31,0,textcol,"country statistics");
 
   y = 2;
   border = 65000;

   do
   {
      hlp = firstcountry;
      max = 0;
      while(hlp)
      {
         if(hlp->worked > max && hlp->worked < border) max = hlp->worked;
         hlp = hlp->next;
      };
      border = max;
      if(max)
      {
         hlp = firstcountry;
         while(hlp)
         {
            if(hlp->worked == max)
            {
               dprintf(1,y,textcol,"%-20s:",hlp->name_eng);
               dprintf(22,y,textcol,"%4u QSO%c",max,max!=1?'s':' ');
               prozent = (float)max*100/h.qso_cnt;
               if(prozent>=10.0) dprintf(32,y,textcol,"(%2.1f%%)",prozent);
               else dprintf(32,y,textcol,"( %1.1f%%)",prozent);
               dprintf(41,y,textcol,"%s %6ld %s","with",hlp->points,"points");
               prozent = (float)hlp->points*100/h.points;
               if(prozent>=10.0) dprintf(61,y,textcol,"(%2.1f%%)",prozent);
               else dprintf(61,y,textcol,"( %1.1f%%)",prozent);
               y++;
            };
            hlp = hlp->next;
         };
      };
   } while(max);
  
   dprintf(2,20,textcol,"%u QSO%s, %u invalid QSO%s, %u km/QSO, %ld points",h.qso_cnt,h.qso_cnt==1?"":"s",h.invalid,h.invalid==1?"":"s",h.average,h.points);
   dprintf(2,21,textcol,"ODX: %u km (%s)",h.ODX,h.ODX_call);
   dprintf(2,22,textcol,"%u countr%s (%u call%s with unknown prefix), %u square%s",h.countries,h.countries==1?"y":"ies",h.unknown_pref,h.unknown_pref==1?"":"s",h.squares,h.squares==1?"":"s");
   dprint(36,lastline,textcol,"any key");
  
   if(!getch()) getch();
  
   drestore(save);
   sec_free(save);
};

  
#define POINTS     1
#define QSOS       2
#define AVERAGE    3
#define POINTS_KUM 4
#define QSOS_KUM   5

void val_calc(unsigned long i, pchar s)
{
   uchar s2[3];

   if(i<10000)
   {
      sprintf(s,"%ld",i);
      return;
   };

   sprintf(s,"%ldk",i/1000);

   i = i%1000;
   if(i)
   {
      sprintf(s2,"%ld",i/100);
      strcat(s,s2);
   };
   return;
};


void do_time_stat(BOOL do_bars)
{
   struct qso *q;

   unsigned qsos[24];
   unsigned qsos_kum[24];
   unsigned long points[24];
   unsigned long points_kum[24];
   unsigned average[24];

   unsigned long i;
   unsigned long step;

   unsigned max_qso = 0;
   unsigned long max_point = 0;
   unsigned max_average = 0;
   unsigned long max;

   float qso_ratio;
   float point_ratio;
   float average_ratio;
   float qsos_kum_ratio;
   float points_kum_ratio;
   float ratio;

   unsigned bar_ratio;
   uchar s[80];
   unsigned y;
   unsigned old_x;
   unsigned old_y;
   uchar ch;

   uchar disp_mode;
   uchar paint;

  
   if(!graphics) return;
   if(!(h.qso_cnt-h.invalid)) return;

   memset(qsos,0,sizeof(qsos));
   memset(points,0,sizeof(points));
   memset(average,0,sizeof(average));
   memset(qsos_kum,0,sizeof(qsos_kum));
   memset(points_kum,0,sizeof(points_kum));

   q = firstqso;
   while(q)
   {
      if(q->points) qsos[q->hour]++;
      points[q->hour]+=q->points;
      q = q->next;
   };

   qsos_kum[14] = qsos[14];
   points_kum[14] = points[14];
   for(i=15;i<24;i++)
   {
      qsos_kum[i]=qsos_kum[i-1]+qsos[i];
      points_kum[i]=points_kum[i-1]+points[i];
   };
 
   qsos_kum[0] = qsos_kum[23]+qsos[0];
   points_kum[0] = points_kum[23]+points[0];
   for(i=1;i<14;i++)
   {
      qsos_kum[i]=qsos_kum[i-1]+qsos[i];
      points_kum[i]=points_kum[i-1]+points[i];
   };

  
   for(i=0;i<24;i++)
   {
      if(qsos[i]>max_qso) max_qso = qsos[i];
      if(points[i]>max_point) max_point = points[i];

      if(qsos[i]) average[i] = (points[i]/qsos[i]);
      if(average[i]>max_average) max_average = average[i];
   };

   qso_ratio = (float)((float)(ymax-60)/max_qso);
   point_ratio = (float)((float)(ymax-60)/max_point);
   average_ratio = (float)((float)(ymax-60)/max_average);
   qsos_kum_ratio = (float)((float)(ymax-60)/h.qso_cnt);
   points_kum_ratio = (float)((float)(ymax-60)/h.points);

   bar_ratio = (int)(xmax-80)/24;
  
   disp_mode = POINTS;
  
   graph_mode();
  
   do
   {
      paint = 0;

      setfillstyle(SOLID_FILL,BLACK);
      bar(0,0,xmax,ymax);
 
      setcolor(maptextcol);
      setlinestyle(SOLID_LINE,0,1);
      line(50,ymax-40,xmax-30,ymax-40);
      line(50,20,50,ymax-40);
      line(xmax-30,20,xmax-30,ymax-40);
  
 
      setcolor(maptextcol);
      switch(disp_mode)
      {
         case POINTS:
            strcpy(s,"Points in dependency of the time");
            break;
         case QSOS:
            strcpy(s,"QSOs in dependency of the time");
            break;
         case AVERAGE:
            strcpy(s,"Average points per QSO in dependency of the time");
            break;
         case POINTS_KUM:
            strcpy(s,"Cumulative points in dependency of the time");
            break;
         case QSOS_KUM:
            strcpy(s,"Cumulative QSOs in dependency of the time");
            break;
      };
      outtextxy((xmax-textwidth(s))/2,2,s);
  
      setcolor(bordercol);
      switch(disp_mode)
      {
         case POINTS:
            step = 100;
            while((max_point/step)>10) step+=100;
            max = max_point;
            ratio = point_ratio;
            break;
         case QSOS:
            step = 5;
            while((max_qso/step)>10) step+=5;
            max = max_qso;
            ratio = qso_ratio;
            break;
         case AVERAGE:
            step = 20;
            while((max_average/step)>10) step+=20;
            max = max_average;
            ratio = average_ratio;
            break;
         case POINTS_KUM:
            step = 1000;
            while((h.points/step)>10) step+=1000;
            max = h.points;
            ratio = points_kum_ratio;
            break;
         case QSOS_KUM:
            step = 5;
            while((h.qso_cnt/step)>10) step+=5;
            max = h.qso_cnt;
            ratio = qsos_kum_ratio;
            break;
      };

      for(i=step;i<max;i+=step)
      {
         val_calc(i,s);
         y = ymax-40-(i*ratio);
         setlinestyle(SOLID_LINE,0,1);
         line(42,y,49,y);
         setlinestyle(DOTTED_LINE,0,1);
         line(51,y,xmax-31,y);
         outtextxy(21-(textwidth(s)>>1),y-3,s);
      };


      if(y > 25)
      {
         val_calc(max,s);
         y = ymax-40-(max*ratio);
         setlinestyle(SOLID_LINE,0,1);
         line(42,y,49,y);
         outtextxy(21-(textwidth(s)>>1),y-3,s);
      };

      switch(disp_mode)
      {
         case POINTS:
         case AVERAGE:
         case POINTS_KUM:
            strcpy(s,"points");
            break;
         case QSOS:
         case QSOS_KUM:
            strcpy(s,"QSOs");
            break;
      };
           
      outtextxy(3,5,s);

      if((disp_mode == POINTS_KUM) || (disp_mode == QSOS_KUM))
      {
         setcolor(mapcol);
         setlinestyle(DOTTED_LINE,0,1);

         for(i=10;i<=90;i+=10)
         {
            sprintf(s,"%2d",i);
            y = ymax-40-(i*(ymax-60)/100);
            line(51,y,xmax-31,y);
            outtextxy(xmax-textwidth(s),y-3,s);
         };
         line(51,20,xmax-31,20);
         strcpy(s,"100");
         outtextxy(xmax-textwidth(s),17,s);
         strcpy(s,"Percent");
         outtextxy(xmax-textwidth(s)-3,5,s);
      };

      i = 14;
      old_x = 0;
      do
      {
         switch(disp_mode)
         {
            case POINTS:
               step = points[i];
               break;
            case QSOS:
               step = qsos[i];
               break;
            case AVERAGE:
               step = average[i];
               break;
            case POINTS_KUM:
               step = points_kum[i];
               break;
            case QSOS_KUM:
               step = qsos_kum[i];
               break;
         };

         if(do_bars)
         {
            setlinestyle(SOLID_LINE,0,1);
            setcolor(maptextcol);
            setfillstyle(SOLID_FILL,mapcol);
            settextstyle(0,VERT_DIR,1);
            settextjustify(CENTER_TEXT,TOP_TEXT);

            bar3d(old_x+59,ymax-40-(step*ratio),
                  old_x+bar_ratio+50,ymax-40,(bar_ratio-10)/4,1);

            if(step)
            {
               sprintf(s,"%ld",step);
               y = 45;
               if((step*ratio)-15<textwidth(s)) y = 50+(step*ratio);
               outtextxy(old_x+59+((bar_ratio-9)>>1),ymax-y-textwidth(s),s);
            };
         }
         else
         {
            if(!old_x) old_y = ymax-40-(step*ratio);
            else
            {
               setcolor(mapcol);
               setlinestyle(SOLID_LINE,0,3);
               line(old_x+54-(bar_ratio>>1),old_y,old_x+54+(bar_ratio>>1),ymax-40-(step*ratio));

               setcolor(maptextcol);
               setfillstyle(SOLID_FILL,maptextcol);
               pieslice(old_x+54-(bar_ratio>>1),old_y,0,360,2);

               old_y = ymax-40-(step*ratio);
            };
         };

         settextstyle(0,HORIZ_DIR,1);
         settextjustify(LEFT_TEXT,TOP_TEXT);
         setcolor(maptextcol);
         sprintf(s,"%02d",i);
         outtextxy(old_x+60-(bar_ratio/2),ymax-35,s);
  
         old_x+=bar_ratio;

         i++;
         if(i>23) i = 0;
      } while(i!=14);

      if(!do_bars)
      {
         setcolor(maptextcol);
         setfillstyle(SOLID_FILL,maptextcol);
         pieslice(old_x+54-(bar_ratio>>1),old_y,0,360,2);
      };

      setcolor(maptextcol);
      outtextxy((24*bar_ratio)+60-(bar_ratio/2),ymax-35,"14");
 
      outtextxy(42-textwidth("UTC"),ymax-34,"UTC");
  
  
      setcolor(maptextcol);
      outtextxy(10,ymax-8,"any key...");
      outtextxy((xmax/2)+10,ymax-8,"FiveNine by Stefan Pfeiffer, DL1ELY");
 
      sprintf(s,"%c %c: change statistics - F1: bars/lines - P: print - CR,ESC,Space: quit",24,25);
      outtextxy((xmax-textwidth(s))>>1,ymax-20,s);
  
      do
      {
         ch = getch();
         if(!ch)
         {
            ch = getch();
            if(ch == 80)
            {
               paint = 1;
               disp_mode--;
               if(!disp_mode) disp_mode = QSOS_KUM;
            };
            if(ch == 72)
            {
               paint = 1;
               disp_mode++;
               if(disp_mode>QSOS_KUM) disp_mode = POINTS;
            };
            if(ch == 59)
            {
               paint = 1;
               do_bars = !do_bars;
            };
         }
         else
         {
            if(toupper(ch) == 'P') pio_print_screen(printport);
            if(ch == 13) ch = 27;
            if(ch == 32) ch = 27;
         };
      } while((ch != 27) && (!paint));

   } while(ch != 27);


   text_mode();
   my_gotoxy(80,lastline+1);
};

// Zeigt eine Karte aller Stationen ber xx KM an.
void do_dx_map()
{
   unsigned kilometers;
   uchar hlp[20];
   void *save;
   uchar result;
   struct qso *q;
   uchar ch;


   if(!graphics) return;
  
   kilometers = (int)h.ODX*0.75;
   sprintf(hlp,"%d",kilometers);
        
   save = make_win(55,3,75,6,menucol);

   dprintf(57,4,menucol,"%s (km)","  distance");
        
   result = input_string(56,5,18,0,DIGITS_ONLY,menuinvcol,hlp);
        
   drestore(save);
   sec_free(save);
        
   kilometers = atoi(hlp);
        
   if(result&&kilometers)
   {
      if(graph_mode())
      {
         display_grid();
         display_map(h.owncall,h.ownloc);
         display_borders();
         q = firstqso;
         while(q)
         {
            if(q->points>=kilometers)
            {
               strcpy(hlp,q->call);
               make_norm_call(hlp,hlp);
               display_path(h.ownloc,q->locator,hlp);
            };
            q = q->next;
         };
         display_loc(h.ownloc,h.owncall);
         ch = getch();
         if(toupper(ch) == 'P') pio_print_screen(printport);
         if(!ch) getch();
         text_mode();
      };
   };
  
   my_gotoxy(80,lastline+1);
};

// Zeigt eine Karte ALLER gearbeiteten Stationen an.
void do_all_map()
{
   struct qso *q;
   unsigned x1, y1, x2, y2;
   double e1, n1, e2, n2;
   char ch;


   if(!graphics) return;
  
   if(graph_mode())
   {
      display_grid();
      display_map(h.owncall,h.ownloc);
      display_borders();

      setcolor(maptextcol);
      loc2coord(h.ownloc,&e1,&n1);

      x1 = (int)((e1-map_left)*1000*scale);
      y1 = (int)((map_top-n1)*1000*scale);

      q = firstqso;
      while(q)
      {
         if(q->points > 20)
         {
            loc2coord(q->locator,&e2,&n2);
  
            x2 = (int)((e2-map_left)*1000*scale);
            y2 = (int)((map_top-n2)*1000*scale);
  
            line(x1,y1,x2,y2);
         };
         q = q->next;
      };
      setcolor(BLACK);
      setfillstyle(SOLID_FILL,BLACK);
      pieslice(x1,y1,0,360,4);

      ch = getch();
      if(toupper(ch) == 'P') pio_print_screen(printport);
      if(!ch) getch();
      text_mode();
   };
  
   my_gotoxy(80,lastline+1);
};

// zeigt eine Textstatistik aller QSOS/Punkte.
void show_qso_stat()
{
   void *save;
   struct qso *hlp;
   unsigned qsos[24];
   unsigned long points[24];
   uchar i;


   memset(&qsos,0,sizeof(qsos));
   memset(&points,0,sizeof(points));

   hlp = firstqso;
   while(hlp)
   {
      if(hlp->points)
      {
         qsos[hlp->hour]++;
         points[hlp->hour]+=hlp->points;
      }
      hlp = hlp->next;
   }

   save = dsave(0,0,lastrow,lastline);

   dfill(0,0,lastrow,lastline,' ',textcol);
   dprint(33,0,textcol,"QSO statistics");

   for(i=14;i<24;i++)
      dprintf(1,i-10,textcol,"%02u:00 %s %02u:59:%3u QSO%c,%5ld %s",i,"to",i,qsos[i],qsos[i]==1?' ':'s',points[i],"points");

   for(i=0;i<14;i++)
      dprintf(42,i+4,textcol,"%02u:00 %s %02u:59:%3u QSO%c,%5ld %s",i,"to",i,qsos[i],qsos[i]==1?' ':'s',points[i],"points");


   dprintf(2,20,textcol,"%u QSO%s, %u invalid QSO%s, %u km/QSO, %ld points",h.qso_cnt,h.qso_cnt==1?"":"s",h.invalid,h.invalid==1?"":"s",h.average,h.points);
   dprintf(2,21,textcol,"ODX: %u km (%s)",h.ODX,h.ODX_call);
   dprintf(2,22,textcol,"%u countr%s (%u call%s with unknown prefix), %u square%s",h.countries,h.countries==1?"y":"ies",h.unknown_pref,h.unknown_pref==1?"":"s",h.squares,h.squares==1?"":"s");

   dprint(37,lastline,textcol,"any key");

   if(!getch()) getch();

   drestore(save);
   sec_free(save);
};


// zeigt die grafische Grofeldkarte an.
void show_square_graph()
{
   double square_x, square_y;
   unsigned middle_x, middle_y;
   int x, y;
   struct squareinfo *hlp;
   uchar s[10];
   uchar ch;

   square_x = (double)(2000.0*scale);
   square_y = (double)(1000.0*scale);

   middle_x = (unsigned)((-map_left*scale*1000.0)+1.5);
   middle_y = (unsigned)(((map_top-50)*scale*1000.0)+0.5);

   if(!graphics) return;
   if(graph_mode())
   {
      display_grid();
      display_map(h.owncall,h.ownloc);
      display_borders();

      setcolor(maptextcol);
      settextjustify(CENTER_TEXT,CENTER_TEXT);

      hlp = firstsquare;
      while(hlp)
      {
         loc2rel(hlp->name,&x,&y);
         y--;
         x = (int)(((double)x*square_x)+(double)(square_x/2.0)+(double)middle_x+0.5);
         y = (int)(((double)y*square_y)+(double)(square_y/2.0)+(double)middle_y+0.5);

         sprintf(s,"%d",hlp->worked);
         if(!strncmp(h.ownloc,hlp->name,4)) setcolor(RED);
         outtextxy(x,y,s);
         if(!strncmp(h.ownloc,hlp->name,4)) setcolor(maptextcol);
         hlp = hlp->next;
      };

      ch = getch();
      if(toupper(ch) == 'P') pio_print_screen(printport);
      if(!ch) getch();
      text_mode();
   };
};

// Zeigt die Speicherstatistik an.
void do_mem_stat()
{
/*   void far *save;
   struct ems_ib ems_info;
   struct xms_ib xms_info;


   save = make_win(10,3,70,14,menucol);
   if(!save) out_of_mem();

   dprint(34,4,menucol,"memory info");

   dprint(12,6,menucol,"DOS:");
   dprintf(17,6,menucol,"%u.%02u",_osmajor,_osminor);
   if(is_windows()) dprint(23,6,menucol,"(Windows)");
   if(is_os2()) dprint(23,6,menucol,"(OS/2)");


/*   dprint(12,7,menucol,"EMS:");

   x_ems_info(&ems_info);
   if(!ems_info.inst) dprint(17,7,menucol,"---");
   else
   {
      if(lang) dprintf(17,7,menucol,"%u.%02u, %dkB frei, Pageframe bei 0x%04X%s",ems_info.ver_hi,ems_info.ver_lo,ems_info.free,ems_info.startseg,ems_info.used?"":" (ungenutzt)");
          else dprintf(17,7,menucol,"%u.%02u, %dkB free, pageframe at 0x%04X%s",ems_info.ver_hi,ems_info.ver_lo,ems_info.free,ems_info.startseg,ems_info.used?"":" (unused)");
   };

   dprint(12,8,menucol,"XMS:");
   x_xms_info(&xms_info);
   if(!xms_info.inst) dprint(17,8,menucol,"---");
   else
   {
      if(lang) dprintf(17,8,menucol,"%u.%02u (Rev. %u.%02u), %dkB frei%s",xms_info.ver_hi,xms_info.ver_lo,xms_info.rev_hi,xms_info.rev_lo,xms_info.free,xms_info.used?"":" (ungenutzt)");
          else dprintf(17,8,menucol,"%u.%02u (Rev. %u.%02u), %dkB free%s",xms_info.ver_hi,xms_info.ver_lo,xms_info.rev_hi,xms_info.rev_lo,xms_info.free,xms_info.used?"":" (unused)");
   };

   dprint(12,10,menucol,lang?"Datenbank (Call-Index):":"database (call-index) :");
   if(!calls) dprint(36,10,menucol,"---kB");
   else
   {
      mem = MK_FP(calls,0);
      dprintf(36,10,menucol,"%3dkB,",mem->l2/1024);   
      switch(mem->type)
      {
         case DOSRAM:
            dprintf(43,10,menucol,"RAM %s 0x%04X%s",lang?"bei":"at",calls,calls<0xA000?"":" (UMB)");
            break;
         case EMS:
            dprintf(43,10,menucol,"EMS");
            break;
         case XMS:
            dprint(43,10,menucol,"XMS");
            break;
      };
   };

   dprint(12,12,menucol,lang?"EU-Karte  :":"EU-map    :");
   if(!map) dprint(24,12,menucol,"--kB");
   else
   {
      mem = MK_FP(map,0);
      dprintf(24,12,menucol,"%2dkB,",mem->l2/1024);
      switch(mem->type)
      {
         case DOSRAM:
            dprintf(30,12,menucol,"RAM %s 0x%04X%s",lang?"bei":"at",map,map<0xA000?"":" (UMB)");
            break;
         case EMS:
            dprintf(30,12,menucol,"EMS");
            break;
         case XMS:
            dprint(30,12,menucol,"XMS");
            break;
      };
   };

   dprint(12,13,menucol,lang?"EU-Grenzen:":"EU-borders:");
   if(!border) dprint(24,13,menucol,"--kB");
   else
   {
      mem = MK_FP(border,0);
      dprintf(24,13,menucol,"%2dkB,",mem->l2/1024);
      switch(mem->type)
      {
         case DOSRAM:
            dprintf(30,13,menucol,"RAM %s 0x%04X%s",lang?"bei":"at",border,border<0xA000?"":" (UMB)");
            break;
         case EMS:
            dprintf(30,13,menucol,"EMS");
            break;
         case XMS:
            dprint(30,13,menucol,"XMS");
            break;
      };
   };

   my_gotoxy(80,lastline+1);

   if(!getch()) getch();

   drestore(save);
   lowfree(save);*/
};

