// TOOLS.C
// Written by Stefan Pfeiffer, DL1ELY, 950105
// Last modification: 950226
// (C) 1995 by Stefan Pfeiffer, DL1ELY

#include "tools.h"
#include <dir.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>

char error_file[128];
extern char *fn_path;

// Setzt den Dateinamen fr das Error-Log, NULL = Aus
void start_log(char *name)
{
   FILE *err_file;

   if(!name)
   {
      error_file[0] = 0;
      return;
   };
   generate_path(fn_path,name,"\0",error_file);

   if(error_file[0])
   {
      err_file = fopen(error_file,"wt");
     fclose(err_file);
   };
};

// Schreibt eine Logmeldung
void error_log(char *module,const unsigned char *fmt, ...)
{
   va_list arg;
   char s[256];
   FILE *err_file;

   if(!error_file[0]) return;

   if((err_file = fopen(error_file,"at")) == NULL) return;

   va_start(arg,fmt);
   vsprintf(s,fmt,arg);
   va_end(arg);

   fprintf(err_file,"%s: %s\n",module,s);
   fclose(err_file);
};


// Liefert TRUE, wenn Windows aktiv ist...
unsigned is_windows(void)
{
   return(getenv("windir")!=NULL);
};

// Liefert TRUE, wenn OS/2 aktiv ist...
unsigned is_os2(void)
{
   return(_osmajor>=10);
};
  
// Generiert aus Default-Pfad, Name und Default-Extension einen Dateinamen...
void generate_path(char *dir, char *name, char *ext, char *res)
{
   char drive1[3];
   char drive2[3];
   char path1[128];
   char path2[128];
   char dummy[10];
   char name1[10];
   char ext1[5];
  
   fnsplit(dir,drive1,path1,dummy,dummy);
   fnsplit(name,drive2,path2,name1,ext1);
  
   res[0] = 0;
   strcpy(res,drive2[0]?drive2:drive1);
   strcat(res,path2[0]?path2:path1);
   strcat(res,name1);
   strcat(res,ext1[0]?ext1:ext);
};

